/***************************************************************************
 *   Copyright (C) 2005, 2006 by Hannes Hauswedell                         *
 *   hannes.hauswedell@gmail.com                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "bsdport.h"


/**------class T_function------**/
T_function::T_function(void (QBsdPortGlobal::*Function)(void), int Ident)
{

	parent 		= (void*)QBsdPort::global;
	function1 	= Function;
	ident 		= Ident;
	whichParent 	= 1;
	
	
}

T_function::T_function(void (QBsdPortGlobal::*Function)(QString, int, bool), int Ident, QString Term, int Criterium, bool Exact)
{

	parent 		= (void*)QBsdPort::global;
	function1a 	= Function;
	ident 		= Ident;
	whichParent 	= 1;
	
	string		= Term;
	integer[0]	= Criterium;
	boolean		= Exact;
	
}

T_function::T_function(void (QBsdPortGlobal::*Function)(int), int Ident, int build)
{

	parent 		= (void*)QBsdPort::global;
	function1b 	= Function;
	ident 		= Ident;
	whichParent 	= 1;
	
	integer[0]	= build;
	
}

T_function::T_function(void (QBsdPortGlobal::*Function)(QBsdPort*, int, int, int, bool, QString), int Ident,
		QBsdPort* Port, int aim, int recursive, int binsource, bool ignore, QString env)
{

	parent 		= (void*)QBsdPort::global;
	function1c 	= Function;
	ident 		= Ident;
	whichParent 	= 1;

	bsdport		= Port;
	integer[0]	= aim;
	integer[1]	= recursive;
	integer[2]	= binsource;
	boolean		= ignore;
	string		= env;


}

T_function::T_function(void (QBsdPortGlobal::*Function)(QBsdPort*, int, bool), int Ident,
		QBsdPort* Port, int recursive, bool ignore)
{

	parent 		= (void*)QBsdPort::global;
	function1d 	= Function;
	ident 		= Ident;
	whichParent 	= 1;

	bsdport		= Port;
	integer[0]	= recursive;
	boolean		= ignore;


}

void T_function::run()
{
	
	switch(whichParent)
	{
		case 1:
	  		if (ident == 6)	/// search
				(((QBsdPortGlobal*)parent)->*function1a)(string, integer[0], boolean);
			else if (ident == 8) /// update index
				(((QBsdPortGlobal*)parent)->*function1b)(integer[0]);
			else if (ident == 10) /// install Port
				(((QBsdPortGlobal*)parent)->*function1c)(bsdport, integer[0], integer[1], integer[2], boolean, string);
			else if (ident == 11) /// uninstall Port
				(((QBsdPortGlobal*)parent)->*function1d)(bsdport, integer[0], boolean);
			else
				(((QBsdPortGlobal*)parent)->*function1)();
//			((QBsdPortGlobal*)parent)->emitSignal(ident);
			QApplication::postEvent(((QBsdPortGlobal*)parent), new QCustomEvent(1000 + ident));
			break;
		case 2:
			(((QBsdPort*)parent)->*function2)();
//			((QBsdPort*)parent)->emitSignal(ident);
			QApplication::postEvent(((QBsdPort*)parent), new QCustomEvent(1000 + ident));
			break;
		case 3:
	  		if (ident!=2)
				(((QBsdPortInstPkg*)parent)->*function3)();
			else
				(((QBsdPortInstPkg*)parent)->*function3b)(string);
//			((QBsdPortInstPkg*)parent)->emitSignal(ident);
			QApplication::postEvent(((QBsdPortInstPkg*)parent), new QCustomEvent(1000 + ident));
			break;
		case 4:
			(((QBsdPortAvSrcPkg*)parent)->*function4)();
//			((QBsdPortAvSrcPkg*)parent)->emitSignal(ident);
			QApplication::postEvent(((QBsdPortAvSrcPkg*)parent), new QCustomEvent(1000 + ident));
			break;
		case 5:
			(((QBsdPortAvBinPkg*)parent)->*function5)();
//			((QBsdPortAvBinPkg*)parent)->emitSignal(ident);
			QApplication::postEvent(((QBsdPortAvBinPkg*)parent), new QCustomEvent(1000 + ident));
			break;
	}

//		emit finished();
//	delete this;
}




/** ------ class QBsdPortGlobal ---------- **/
void QBsdPortGlobal::guessPlatform()
{
	platform.pkgsystem = 0;
	platform.os	= 0;
	platform.mirror	= "";
	platform.release = "6.1-release";

}

void QBsdPortGlobal::guessOtherEnv()
{
	FILE	*lPipe;
	char 	buffer[250] = "";
	int 	i = -1;

	/// needs to be initialized to |, see findAllAvSrc for details
	multiPorts = "|";

	/** portsdir **/
	if( (lPipe = popen( "echo $PORTSDIR", "r" )) == NULL )
 		return ;
	
	fgets( buffer, 250, lPipe ); 	
	pclose(lPipe);
	
	do
	{
		i++;
		
		if (buffer[i]=='\n')
			buffer[i]=0;
		if (buffer[i]==' ')
			buffer[i]=0;
		
	} while ( (buffer[i]!=0) && (i<249) );

	portsDir = buffer;

	if (portsDir == "") /// no env set -> defaults
	{
		if (platform.pkgsystem==2)
			portsDir = "/usr/pkgsrc/";
		else
			portsDir = "/usr/ports/";
	}
	else
		if (!portsDir.endsWith("/"))	/// make sure var terminates in "/"
			portsDir+="/";

	/** pkgpath **/
/*	if( (lPipe = popen( "echo $PACKAGESITE", "r" )) == NULL )
 		return;
	buffer[0]=0;
	fgets( buffer, 250, lPipe ); 	
	pclose(lPipe);
	buffer[249]=0;
	do
	{
		i++;
		
		if (buffer[i]=='\n')
			buffer[i]=0;
		if (buffer[i]==' ')
			buffer[i]=0;
		
	} while ( (buffer[i]!=0) && (i<249) );

	pkgSite = buffer;

	if ( pkgSite == "")
		 
	if (!pkgSite.endsWith("/")) 
			pkgSite+="/";*/
			
	if (platform.mirror == "")
		pkgSite = "ftp://ftp.freebsd.org/pub/FreeBSD/ports/i386/packages-" + platform.release + "/Latest/";
	else if (platform.mirror.startsWith("main"))
		pkgSite = "ftp://ftp" + platform.mirror[4] + ".freebsd.org/pub/FreeBSD/ports/i386/packages-" + platform.release + "/Latest/";
	else
		pkgSite = "ftp://ftp." + platform.mirror + ".freebsd.org/pub/FreeBSD/ports/i386/packages-" + platform.release + "/Latest/";
		
	/**default values for other vars**/
	pkgDbDir	= "/var/db/pkg/";
	portsDbDir	= "/var/db/ports/";

	indexPath	= portsDir + "INDEX-" + platform.release[0];

	pkgCount	= 0;

	portaudit	= QFile::exists("/usr/local/sbin/portaudit");
	portsnatch	= QFile::exists("/usr/local/bin/portsnatch");

	updDate 	= 20040101;

	debug		= 1; ///TODO: change to false before release
	
	
	keepLogsForSuccessfulProcs = false;
	combinePkgInfo	= true;
	
	ui_user_id	= geteuid();

}

void QBsdPortGlobal::findAllAvailableSrc()
{


	QString 	buffer("");
//	QString 	exists="";	///saves a list of processed pkgnames
	QString		dep="";
	QStringList	tmp="";
	QStringList	tmp2="";
	QBsdPort 	*tmpport;
	QBsdPortAvSrcPkg *tmpversion;
	bool		firstrun = 0;
	bool		hadToInteruptFindAvBinProc = 0;
	
	if (array.count() == 0)
		firstrun = 1;

	if (firstrun)
		qDebug("firstrun");
	
	
	QFile file(indexPath);

	if (activeProcs.contains("findAllAvBinProc"))
	{
		stopProc("findAllAvBinProc");
		hadToInteruptFindAvBinProc = 1;
	}
		

	if (!file.exists())
	{
//		std::cout << file.name()<<endl;
		
//		emit indexFileNotFound();
///not threadsafe, instead
		QApplication::postEvent(this, new QCustomEvent(1110));
		return;
	}

	if (!firstrun)
		for (tmpport = array.first(); tmpport; tmpport = array.next()) 	/// clear old contents
			tmpport->setAvSource(0);

	file.open(IO_ReadOnly);

	int	number = 0;

	while (!file.atEnd())
	{
		number++;
		
		file.readLine(buffer, 15000);
		
//		QString Name = (buffer.section('|', 0,0)).section('-', 0,-2);
		
		tmp2 = QStringList::split('|', buffer, true); 
		

		tmpversion = new QBsdPortAvSrcPkg();

/*		tmpversion->setVersion((buffer.section('|', 0,0)).section('-', -1,-1));
		tmpversion->setName((buffer.section('|', 0,0)).section('-', 0,-2));
		tmpversion->setPrefix(buffer.section('|', 2,2));
		tmpversion->setComment(buffer.section('|', 3,3));
		tmpversion->setMaint(buffer.section('|', 5,5));
		tmpversion->setCategories(buffer.section('|', 6,6));
		tmpversion->setWWW(buffer.section('|', 9,9));

		QString dep = buffer.section('|', 7,7); 
		/// add those builddeps to 'dep' that arent already there
		/// because they are also run deps
//		dep += " "; /// add an extra space so build deps may be seperated from rundeps again
		tmp = QStringList::split(' ', buffer.section('|', 8,8));	
		for ( QStringList::Iterator it = tmp.begin(); it != tmp.end(); it++ )
			if (!dep.contains(*it))
				dep+= " " + *it;*/
		tmpversion->setVersion(tmp2[0].section('-', -1,-1));
		tmpversion->setName(tmp2[0].section('-', 0,-2));
		tmpversion->setPrefix(tmp2[2]);
		tmpversion->setComment(tmp2[3]);
		tmpversion->setMaint(tmp2[5]);
		tmpversion->setCategories(tmp2[6]);
		tmpversion->setWWW(tmp2[9]);

		QString dep = tmp2[7]; 
		/// add those builddeps to 'dep' that arent already there
		/// because they are also run deps
//		dep += " "; /// add an extra space so build deps may be seperated from rundeps again
		tmp = QStringList::split(' ', tmp2[8]);	
		for ( QStringList::Iterator it = tmp.begin(); it != tmp.end(); it++ )
			if (!dep.contains(*it))
				dep+= " " + *it;



		tmpversion->setReqs(dep);

		/// those information fields that arent in INDEX are marked as "no_init"
		tmpversion->setDescr("no_init");
		tmpversion->setFiles("no_init");
		tmpversion->setOptions("no_init");
		tmpversion->setVulna("no_init");
		tmpversion->setBroken("no_init");
		tmpversion->setIgnore("no_init");
		tmpversion->setRestricted("no_init");
		tmpversion->setDeprecated("no_init");
		tmpversion->setForbidden("no_init");
		

		if (firstrun || ( (tmpport = portWithOrigin(buffer.section('|', 1,1).section('/', 3,4))) == 0) )
		{
			tmpport = new QBsdPort(tmp2[1].section('/', 3,4)); /// create new master port
			array.append(tmpport);
		}
			
		tmpport->setAvSource(tmpversion);

		
//		if (debug>=2)
//			std::cout << "|| <" << tmpport->origin() << "> added successfully.\n";
	
		
	}


	file.close();

	QString tmplist="|";
	multiPorts = "|";
	/// create list with multiports
	for (tmpport = array.first(); tmpport; tmpport = array.next())
	{
		if (tmpport->avSource())
			if ( (tmplist.contains("|"+tmpport->avSource()->name()+"|")) && (!multiPorts.contains("|"+tmpport->avSource()->name()+"|")) )
				multiPorts += tmpport->avSource()->name()+"|";
			else
				tmplist += tmpport->avSource()->name()+"|";
	} 
	
//	if (hadToInteruptFindAvBinProc)
//		T_findAllAvailableBin();
	
//	if (debug>=1)
//		std::cout << "|| MULTILIST: " << multiPorts.latin1() << " <>.\n";
}


void QBsdPortGlobal::findAllInstalled()
{

	FILE 	*pipe;
	QString cmd="";
	char 	buffer[250]="";
	int	ident=0;	/// says which content, a line belongs to (for content that goes over many lines)
				/// if you dont understand this, look at "pkg_info -pcdDrRLso 'pkgname'" !!
	QString originbuf(""), depbuf(""), reqbuf(""), descrbuf(""), filebuf(""), messagebuf(""), temp("");
	filebuf.reserve(10000);
	QBsdPort *port;
	QBsdPortInstPkg *current = 0;

	cmd	=  "pkg_info -apcdDrRLo -l \"<|>\""; /// get all the infos, added "<|>" to distinguish  text
	
	if( (pipe = popen( cmd.latin1(), "r" )) == NULL )
	{
		std::cout << "buhu";
		return;
	}


	while (!feof(pipe))
	{
		fgets( buffer, 250, pipe );
		buffer[249]=0;
		temp = buffer;
		if ( (ident!=4) && (ident!=5) )
			temp.remove(temp.length()-1,1);///remove std::endline
//		std::std::cout << temp.latin1() <<endl;
		if (temp.startsWith("<|>")) /// a new information section has begun
		{
			temp.remove(0,3); /// remove the cool signs i added
			ident = 0;
		
			if (temp.startsWith("Information for"))
			{
				if (current)	///save data from the last port
				{
					
					if (originbuf=="")
						originbuf = "UNKNOWN/" + current->name();

//					std::cout << "|| saving data for: <" <<originbuf<<">\n";
//					std::cout << "|| has descr: <" <<descrbuf<<">\n";
					port = portWithOrigin(originbuf);
					if (port)
						port->setInstalled(current);
					else
					{
						port = new QBsdPort(originbuf);
						array.append(port);
						port->setInstalled(current);
					}
					if (port->avSource()) /// we will now save memory -> QbsdPortPkg in .h for details
					{
						if (port->avSource()->descr() == descrbuf)
							current->setDescr("s");
						else
							current->setDescr(descrbuf);
						if (port->avSource()->reqs() == reqbuf)
							current->setReqs("s");
						else
							current->setReqs(reqbuf);
						if (port->avSource()->files() == filebuf)
							current->setFiles("s");
						else
							current->setFiles(filebuf);
						/// the following have already been saved
						if (port->avSource()->comment() == current->comment())
							current->setComment("s");
						if (port->avSource()->name() == current->name())
							current->setName("s");
						if (port->avSource()->version() == current->version())
							current->setVersion("s");
						if (port->avSource()->prefix() == current->prefix())
							current->setPrefix("s");
						if (port->avSource()->www() == current->www())
							current->setWWW("s");

						current->setDeps(depbuf);
						current->setMessage(messagebuf);
						current->setSize(0); /// size is detected later for speed reasons
						current->setFalseFiles("no_init"); /// same reason
						current->setVulna("no_init");	/// initialized as 0 problems since find allvulnas gets vulnas for isntalled
						
					} else
					{
						current->setDescr(descrbuf);
						current->setReqs(reqbuf);
						current->setDeps(depbuf);
						current->setMessage(messagebuf);
						current->setFiles(filebuf);
						current->setSize(0); /// size is detected later for speed reasons
						current->setFalseFiles("no_init"); /// same reason
						current->setVulna("no_init"); /// initialized as 0 problems since find allvulnas gets vulnas for isntalled
					}
					
					/// clear the buffers
					originbuf = "";
					depbuf	= "";
					reqbuf = "";
					descrbuf = "";
					filebuf = "";
					messagebuf = "";
				}
				
				temp.remove(temp.length()-1,1);	///remove colon
				///and create a new port
				current = new QBsdPortInstPkg();
				current->setVersion(temp.section(' ',2,2).section('-',-1,-1));
				current->setName(temp.section(' ',2,2).section('-',0,-2));
	
			} else if (temp.startsWith("Comment:"))
				ident = 1;
			else if (temp.startsWith("Depends on:"))
				ident = 2;
			else if (temp.startsWith("Required by:"))
				ident = 3;
			else if (temp.startsWith("Description:"))
				ident = 4;
			else if (temp.startsWith("Install notice:"))
				ident = 5;
			else if (temp.startsWith("Prefix(s):"))
				ident = 6;
			else if (temp.startsWith("Files:"))
				ident = 7;
//			else if (temp.startsWith("Package Size:"))
//				ident = 8;
			else if (temp.startsWith("Origin:"))
				ident = 9;

		} else if ( (temp!="") || ((ident==4) || (ident==5)) ) /// only 4 +5 have empty lines 
			switch (ident)
			{
				case 1: current->setComment(temp); break;
				case 2: temp.remove(0,12);	///remove the "Dependency: "
					reqbuf += " " + temp; break;
				case 3: depbuf	+= " " + temp; break;
				case 4: descrbuf+= temp;
					if (temp.startsWith("WWW:")) /// webpage is part of descr
					{
						temp.remove(0,5);
						temp.remove('\n');
						temp.remove(QChar(13));
						current->setWWW(temp);
					}
					break;
				case 5: messagebuf += temp; break;
				case 6: if (temp!="\tCWD to .")
					{
						temp.remove(0,8);	/// remove the "(tab)CWD to "
						current->setPrefix(temp);
					}
					break;
				case 7: filebuf += "|" + temp; break;
//				case 8: current->setSize(temp.section("\t",0,0).toULong()); break;
				case 9: originbuf = temp; break;
				default: break;
	
			}

	}

	/// since ports are saved in beginning of next, the last one wasnt saved yet
	port = portWithOrigin(originbuf);
	if (port)
		port->setInstalled(current);
	else
	{
		port = new QBsdPort(originbuf);
		array.append(port);
		port->setInstalled(current);
	}

	current->setDescr(descrbuf);
	current->setReqs(reqbuf);
	current->setDeps(depbuf);
	current->setMessage(messagebuf);
	current->setFiles(filebuf);
	pclose(pipe);



}

void QBsdPortGlobal::findAllAvailableBin()
{

	int i = 0;
	QFile file(QDir::homeDirPath() + "/.kports/FTPINDEX");
	QBsdPort *tmpport;
	QBsdPortAvBinPkg *tmppkg;	
	QString buffer("");
	QStringList tmplist = "";
	
	while (toBeStoppedProcs.contains("findAllAvBinProc"))
		toBeStoppedProcs.erase(toBeStoppedProcs.find("findAllAvBinProc"));
	/// append this proc to the list of active procs
	activeProcs.append("findAllAvBinProc");
	
	QApplication::postEvent(this, new QMyEvent(1108, i));
	
	/// delete all information for available bin versions from the array
	for (QBsdPort *port = array.first(); port; port = array.next())
	{
	//	if (port->avBinary())
	//		delete port->avBinary();
		
		port->setAvBinary(0);
	}
	
	i = 1;
	QApplication::postEvent(this, new QMyEvent(1108, i));
	
	if (!updateFTPIndex()) /// try 3 times because server might be busy
		if (!updateFTPIndex())
			if (!updateFTPIndex())
				if (!file.exists()) /// error
				{
					i = 3;
					QApplication::postEvent(this, new QMyEvent(1108, i));
					return;
				} //else /// only warn and use old index)
				
		
	i = 2;
	QApplication::postEvent(this, new QMyEvent(1108, i));

	if (toBeStoppedProcs.contains("findAllAvBinProc") || toBeStoppedProcs.contains("*"))
	{
		activeProcs.erase(activeProcs.find("findAllAvBinProc"));	
		while (toBeStoppedProcs.contains("findAllAvBinProc"))
			toBeStoppedProcs.erase(toBeStoppedProcs.find("findAllAvBinProc"));
			
		
		return;
	}
	
	file.open(IO_ReadOnly);


	while (!file.atEnd())
	{
		if (toBeStoppedProcs.contains("findAllAvBinProc") || toBeStoppedProcs.contains("*"))
		{
			activeProcs.erase(activeProcs.find("findAllAvBinProc"));	
			while (toBeStoppedProcs.contains("findAllAvBinProc"))
				toBeStoppedProcs.erase(toBeStoppedProcs.find("findAllAvBinProc"));
				
			file.close();
			
			return;
		}
		
		file.readLine(buffer, 15000);
		
//		tmpport = new QBsdPort((buffer.section('|', 1,1)).section('/', 3,4)); /// create new master port

		tmppkg = new QBsdPortAvBinPkg();

		tmplist = QStringList::split('|', buffer, true);

		tmppkg->setVersion(tmplist[0].section('-', -1,-1));
		tmppkg->setName(tmplist[0].section('-', 0,-2));
		tmppkg->setPrefix(tmplist[2]);
		tmppkg->setComment(tmplist[3]);
		tmppkg->setMaint(tmplist[5]);
		tmppkg->setCategories(tmplist[6]);
		tmppkg->setWWW(tmplist[9]);
		tmppkg->setReqs(tmplist[8]); /// 7,7 the build deps can be ignored for binary pks

		/// those information fields that arent in INDEX are marked as "no_init"
		tmppkg->setDescr("-");
		tmppkg->setFiles("-");
		tmppkg->setVulna("no_init");

//		while (!getMutex.tryLock());	/// we need to block access to the array, because list in parent might be rebuilt incorrectly if array is being modified
		
		tmpport = portWithOrigin(tmplist[1].section('/', 3,4));

		if (tmpport)
			tmpport->setAvBinary(tmppkg);
		else
		{
//			qDebug("Port with Name \"" + tmppkg->name() + "\" and Origin <" + (buffer.section('|', 1,1)).section('/', 3,4) + "> not found.");
			delete	tmppkg;
		}
		
//		getMutex.unlock();
	}
		
	file.close();
	
	i = 4;
	QApplication::postEvent(this, new QMyEvent(1108, i));


	activeProcs.erase(activeProcs.find("findAllAvBinProc"));	
	while (toBeStoppedProcs.contains("findAllAvBinProc"))
		toBeStoppedProcs.erase(toBeStoppedProcs.find("findAllAvBinProc"));
	
/*	FILE 	*pipe;
	char 	buffer[400]="";
	char	name[50]="", version[50]="";
	QString cmd, Name, Version, Buffer;
	QBsdPortAvBinPkg *newAvBin;
	QBsdPort *port;
	
	cmd = "echo 'ls ' | ftp -V " + pkgSite + "../All/ 2>&1";

	if( (pipe = popen( cmd.latin1(), "r" )) == NULL )
		return;

	
	while ( !feof(pipe) )
	{
		fgets( buffer, 400, pipe ); 
		Buffer = buffer;
		Buffer.remove(Buffer.length()-1, 1); /// remove std::endl
		if ( (Buffer.endsWith(".tbz")) || (Buffer.endsWith(".tgz")) )
		{
			Buffer = Buffer.section(' ',-1,-1);
			Buffer.remove(Buffer.length()-4, 4); /// remove ".tbz" or ".tgz"


			/// get QStrings from arrays
			Name = Buffer.section('-',0,-2);
			Version = Buffer.section('-',-1,-1);

			newAvBin = new QBsdPortAvBinPkg();
			newAvBin->setName(Name);
			newAvBin->setVersion(Version);

			if (multiPorts.contains("|"+Name+"|")) /// this could be package to more than one port
			{
				port = portWithName(Name, 1, Version);

				///TODO: spter kommt hier ein pkg_info check auf die jeweiligen online file hin um den origin festzustellen
			} else
				port = portWithName(Name, 1, Version);

			if (port)
			{
				newAvBin->setDescr("s");
				newAvBin->setComment("s");
				newAvBin->setReqs(port->avSource()->reqs().section("  ",0)); /// run deps are sperated from buildeps by double space
				newAvBin->setWWW("s");
				newAvBin->setVulna("no_init");
				newAvBin->setFiles("s");
				newAvBin->setPrefix("s");
				newAvBin->setSize(0);
				port->setAvBinary(newAvBin);
				if (debug>=2)
					std::cout << "|| " <<port->origin() << " hat jetzt <"<<Version.latin1()<<"> als binro.\n"; 
			} else
				delete newAvBin;
		}
	}

	pclose(pipe);

*/


}

int  QBsdPortGlobal::updateFTPIndex()
{
	KProcIO proc;
	proc.setName("updateFTPIndexProc");
	QString	Buffer(""), err("");
	
	proc.setUseShell(true);
	proc << "echo 'newer INDEX " + QDir::homeDirPath() + "/.kports/FTPINDEX' | ftp -V " + pkgSite + "../ && echo kports_success";
	
	///locate and create the logfile
	QString *logpath = new QString(QDir::homeDirPath() + "/.kports/fetchFTPINDEX.log");
	QFile	logfile(*logpath);
	if (logfile.exists())
		logfile.remove();
	logfile.open(IO_WriteOnly | IO_Append);

	
	QValueList<QCString> stringbu = proc.args(); QString temp(""), total("");
	for (QValueList<QCString>::iterator it = stringbu.begin(); it != stringbu.end(); ++it)
	{
		temp = *it;
		total += temp + " ";
	}
	logfile.writeBlock("--> " + total + "\n", total.length() + 5);
	
	/// append this proc to the list of active procs
	activeProcs.append(proc.name());
	

	proc.start(KProcess::OwnGroup, KProcess::AllOutput); /// ownGroup so children spawned by proc can be killed too + comm=alloutput
	int i = 0;
		
	while (( i = proc.readln(Buffer, false) >= 0) || (proc.isRunning()))
	{
		/// the output will not be processed/interpreted by this call, but instead
		/// by the gui thread, because that has relevant information neede

		
		if (i  > 0)	/// there is output
		{
//			Buffer.remove('\n');
//			Buffer.remove(QChar(13));
			logfile.writeBlock(Buffer, Buffer.length()); 	/// write it to log
		} else	/// insert a delay, without delay kprocio throws SIGABRT
			proc.wait(1);
		
		
		if (toBeStoppedProcs.contains(proc.name()) || toBeStoppedProcs.contains("*")) /// should be interrupted
		{
			proc.kill(SIGINT); /// try to terminate nicely
			if (!proc.wait(2))
				proc.kill(SIGKILL);/// then we kill it
				
			Buffer = "--> Process interrupted by User."; /// get line from output and make it red
			logfile.writeBlock(Buffer, Buffer.length()); 	/// write it to log
		}
		
		if (!Buffer.contains("kports_success"))
			Buffer = "";
	}
	
	/// erase it from both lists
	activeProcs.erase(activeProcs.find(proc.name()));	
	while (toBeStoppedProcs.contains(proc.name()))
		toBeStoppedProcs.erase(toBeStoppedProcs.find(proc.name()));
	
	///close the logfile	
	logfile.close();
			
	if  ((!Buffer.contains("kports_success"))) /// error during process
		return 0;
	else
	{
		if (!keepLogsForSuccessfulProcs)
			logfile.remove();
		
		return 1;
	}



}

void QBsdPortGlobal::readUpdFile()
{
	QString buffer="", prebuffer="", bigbuff="", affects="", tmp="";
	QStringList tmplist;
	QBsdPort *tmpport;
	bool	wasAdded = false;
	
	QFile file(portsDir + "UPDATING");
	QFile out_file(QDir::homeDirPath() + "/.kports/rest_of_updating");
	
	if (out_file.exists())
		out_file.remove();	

	out_file.open(IO_WriteOnly);

	if (!file.exists())
	{
		std::cout << file.name()<< std::endl;
		QApplication::postEvent(this, new QCustomEvent(1110));
		return;
	}

	file.open(IO_ReadOnly);

	//skip the introduction and go to first warning
	while (!buffer.startsWith("  AFFECTS:"))
	{
		prebuffer = buffer;
		file.readLine(buffer, 500);
	}
	
	/// the following loop reads out warning blocks from UPDATING as long as date is wanted
	/// and then finds the ports to add the information to
	while (!file.atEnd() && (prebuffer.left(8).toULong() >= updDate) )
	{
		wasAdded = false;
		
		/// at the beginning of the do-loop prebuffer always holds the date and buffer the affectsline
		affects = buffer; /// affects saves the affect-line in buffer for later use

		bigbuff = prebuffer;
		
		do
		{
			prebuffer = buffer;
			file.readLine(buffer, 500);
			if (!buffer.startsWith("  AFFECTS:"))
				bigbuff += prebuffer;

		} while ( (!buffer.startsWith("  AFFECTS:")) && (!file.atEnd()) );

		affects.remove(0,20); /// remove "  AFFECTS: users of "
		affects.remove(affects.length()-1,1); /// remove std::endline character
		
//		std::cout << "<affects>:" << affects.latin1();
		tmplist = QStringList::split(' ', affects);
		for (QStringList::Iterator it = tmplist.begin();  it != tmplist.end(); it++ )
		{
			tmp = *it;
			if (tmp.contains('/')) // make sure the string is an origin, not "and" or something like that
			{
				if (tmp.endsWith(","))
					tmp.remove(tmp.length()-1,1);

				tmpport = portWithOrigin(tmp);

				if (tmpport)
				{
					if (tmpport->installed())
						tmpport->installed()->setUpdWarning(tmpport->installed()->updWarning() + bigbuff);
						
					wasAdded = true;
				} 
							
			} 
		}
			
			
		if (!wasAdded) /// UPDATING file warning that cannot be matched to a port a preserved in this file
			out_file.writeBlock(bigbuff, bigbuff.length());
			
//		std::cout << bigbuff.latin1() << " | ";

	}
	
	out_file.close();
	file.close();
}

void QBsdPortGlobal::findVulnas()
{
	if (!portaudit)
		return;

	FILE 	*pipe;
	char 	buffer[250]="";
	QString Buffer, tmp;

	QBsdPort *port;
//	QBsdPortInstPkg *current = 0;

	if( (pipe = popen( "portaudit -a 2>&1", "r" )) == NULL )
	{
		std::cout << "buhu";
		return;
	}


	while ( !feof(pipe) )
	{
		fgets( buffer, 250, pipe );  
		Buffer = buffer;
		if (Buffer.startsWith("portaudit: Database")) /// databse missing or too old
		{
//			emit vulnaDbOutdated();
			QApplication::postEvent(this, new QCustomEvent(1111));
			pclose(pipe);
			return;
				
		} else if (Buffer.startsWith("Affected package:"))
		{
			Buffer.remove(0,18); /// remove "affected package:"
			Buffer.remove(Buffer.length()-1,1); /// remove std::endline

			port = portWithName(Buffer.section('-',0,-2), 3, Buffer.section('-',-1,-1));
			
			if (!port)
			{
				if (debug)
					std::cout << "PROBLEM: " << Buffer.latin1() <<  std::endl;
			} else
			{
				fgets( buffer, 250, pipe );  
				Buffer = buffer;
				Buffer.remove(0,17); /// remove "type of problem: "
				Buffer.remove(Buffer.length()-1,1);
				tmp = "\n" + Buffer;  /// newline seperator between different vulnas
			
				fgets( buffer, 250, pipe );  
				Buffer = buffer;
				Buffer.remove(0,17); /// remove "reference: <"
				Buffer.remove(Buffer.length()-2,2); /// remove ">" and std::endline
				tmp += "|" + Buffer; /// | seperator between webaddress and description
				if ( (port->installed()->vulna()!="no_init") && (port->installed()->vulna()!="") )
					port->installed()->setVulna(port->installed()->vulna() + tmp);
				else
					port->installed()->setVulna(tmp);
			}
		}
	}

	pclose(pipe);


}

QBsdPort* QBsdPortGlobal::portWithOrigin(QString Origin)
{

	QBsdPort *r = 0;
	for (QBsdPort *port = array.first(); (port && (r == 0)); port = array.next())
		if (port->origin()==Origin)
			r = port;


//	if (debug && r==0)
//		std::cout << "|| port with origin <" << Origin.latin1() << "> does not exist.\n";

	return r;
}

QBsdPort* QBsdPortGlobal::portWithName(QString Name, int Package = 1, QString Version="")
{
	/** Package can be 
		0 = search avSrcPkg, avBinPkg + instPkg
		1 = avSrcPkg
		2 = avBinPkg
		3 = instPkg
	this flag is available because chosing somthing other than 0 speeds the process up alot
	**/

	bool isMultiPort = false;
	if (multiPorts.contains(Name+"|"))
		isMultiPort = true;

	if (Package <= 1) /// cheack av source packages
		for (QBsdPort *port = array.first(); port; port = array.next())
		{
			if (port->avSource()) /// package exists
			{					
				if (port->avSource()->name()==Name)
					if ( (!isMultiPort) || (Version=="") )
					{
						return port;
					} else
					{
						if (Version==port->avSource()->version())
							return port;
					}
			}
				
	
		}
	if ( (Package == 0) || (Package == 3) ) /// check installed packages
		for (QBsdPort *port = array.first(); port; port = array.next())
		{
			if (port->installed()) /// package exists
			{					
				if (port->installed()->name()==Name)
					if ( (!isMultiPort) || (Version=="") )
					{
						return port;
					} else
					{
						if (Version==port->installed()->version())
							return port;
					}
			}
				
	
		}

	if ( (Package == 0) || (Package == 2) ) /// check av bin packages
		for (QBsdPort *port = array.first(); port; port = array.next())
		{
			if (port->avBinary()) /// package exists
			{					
				if (port->avBinary()->name()==Name)
					if ( (!isMultiPort) || (Version=="") )
					{
						return port;
					} else
					{
						if (Version==port->avBinary()->version())
							return port;
					}
			}
				
	
		}

//	qDebug("|| port with name <" + Name + ">, version <" + Version + "> and type <" + QString::number(Package) + "> does not exist.\n");

	return NULL;
}

void QBsdPortGlobal::searchFrame(QString Term, int Criterium, bool Exact)
{
	QPtrList <QBsdPort> list = search(Term, Criterium, Exact);

	QApplication::postEvent(this, new QMyEvent(1120, list));

}

QPtrList <QBsdPort> QBsdPortGlobal::search(QString Term, int Criterium, bool Exact)
{
	/** Package can be 
		0 = search avSrcPkg, avBinPkg + instPkg
		1 = avSrcPkg
		2 = avBinPkg
		3 = instPkg
	this flag is available because chosing somthing other than 0 speeds the process up alot
	**/

	QPtrList <QBsdPort> result;

	QBsdPort *port; 
	QString compTerm;
	
	bool	add=false;


	for (QBsdPort *port = array.first(); port; port = array.next())
	{
		add = false;
		compTerm = "";
		
		if (port->avSource()) /// package exists
		{

			switch(Criterium)
			{
				case 0: /// name
					compTerm = port->avSource()->name(); break;
				case 1: /// categories
					compTerm = port->avSource()->categories(); break;
				case 2: /// maintainer
					compTerm = port->avSource()->maint(); break;
				case 3: /// comment
					compTerm = port->avSource()->comment(); break;
/*				we dont want these guys checked right now
				case 4: /// description
					compTerm = port->avSource()->descr(); break;
				case 5: /// files
					compTerm = port->avSource()->files(); break;*/
				default: break;
			}

			if ( ((Exact) && (compTerm==Term)) || ((!Exact) && (compTerm.contains(Term))) )
				add = true;
		}
		
		if ( (!add) && (port->installed()) )///if port is going to be added anyways we can skip other comparisons
		{

			switch(Criterium)
			{
				case 0: /// name
					compTerm = port->installed()->name(); break;
				case 3: /// comment
					compTerm = port->installed()->comment(); break;
				case 4: /// description
					compTerm = port->installed()->descr(); break;
				case 5: /// files
					compTerm = port->installed()->files(); break;
				default: break;
			}

			if ( ((Exact) && (compTerm==Term)) || ((!Exact) && (compTerm.contains(Term))) )
				add = true;
		}
		
		if ( (!add) && (port->avBinary() ) )/// binary is deactivated for now <-> contains no info the other dont
		{

			switch(Criterium)
			{
				case 0: /// name
					compTerm = port->avBinary()->name(); break;
				case 3: /// comment
					compTerm = port->avBinary()->comment(); break;
				case 4: /// description
					compTerm = port->avBinary()->descr(); break;
				case 5: /// files
					compTerm = port->avBinary()->files(); break;
				default: break;
			}

			if ( ((Exact) && (compTerm==Term)) || ((!Exact) && (compTerm.contains(Term))) )
				add = true;
		}
		
		if (add)
			result.append(port);
			
	}


	return result;

}


void QBsdPortGlobal::updateVulnaDb()
{
	if (!portaudit)
		return;

	FILE 	*pipe;
	char 	buffer[250]="";
	QString Buffer, tmp, complete="";
	bool	success=false;

	if( (pipe = popen( "kdesu --caption=KPorts -t -d -c 'portaudit -F 2>&1'", "r")) == NULL )
	{
		return;
	}

	while ( !feof(pipe) )
	{
		fgets( buffer, 250, pipe );  
		Buffer = buffer;
		if (Buffer.startsWith("New database installed."))
		{
//			emit vulnaDbUpdateSuccessful();
			QApplication::postEvent(this, new QCustomEvent(1112));
			success = true;
		}
		complete += Buffer;
	}
	
	if (!success)
	{
		QApplication::postEvent(this, new QMyEvent(1113, complete));	
//		emit vulnaDbUpdateUnsuccessful(complete);
	}
	pclose(pipe);
			
}

void 	QBsdPortGlobal::updatePortsDir()
{
	/** first we create the supfile **/
	QFile supfile(QDir::homeDirPath() + "/.kports/ports-supfile");
	
	if (supfile.exists())
		supfile.remove();
		
	QString data("");
	
	if ( (platform.mirror == "") || (platform.mirror.startsWith("main")) )
		data = "*default host=cvsup.freebsd.org\n";
	else
		data = "*default host=cvsup." + platform.mirror + ".freebsd.org\n";
		
	///we need a slash in the first two line because of skipemty 	
	data += "*default base=/" + portsDbDir.section('/', 0, -2, QString::SectionSkipEmpty) + "\n";
	data += "*default prefix=/" + portsDir.section('/', 0, -2, QString::SectionSkipEmpty) + "\n";
	data += "*default release=cvs tag=.\n";
	data += "*default delete use-rel-suffix\n";
	data += "*default compress\n";
	data += "ports-all\n";
	
	supfile.open(IO_WriteOnly);
		
	supfile.writeBlock(data, data.length());
		
	supfile.close();
	
	/** then we start cvsup **/
//	FILE*	pipe;
//	char	buffer[400];
	
	KProcIO proc;
	proc.setName("updatePortsDirProc");	/// used as name for the proc	
//	MyProc proc(this, "updatePortsDirProc");
	QString Buffer(""), b2(""), cmd(""), err("");
	QString logpath = QDir::homeDirPath() + "/.kports/cvsup.log";
	QFile	logfile(logpath);
	if (logfile.exists())
		logfile.remove();
	logfile.open(IO_WriteOnly | IO_Append);
		

	uint	counter = 0;
	uint	current = 0, max = pkgCount;
	int	percent = 0, /// how far are we thru the update
		lastpercent = 0, /// a buffer
		tempint = 0,
		wait	= 0;
	QBsdPort* tmpport = 0;
	int	*ptr;
//	ptr 	= &percent;
	bool	indexExists = QFile::exists(indexPath);
	bool	startCounting = false; /// set true as soon as ports are actually updated
		
		
	if ((!indexExists) && (!QFile::exists(portsDir))) /// if portsdir doesnt exist, make it
		cmd += "mkdir " + portsDir + " && "; 
	
	cmd += "cvsup -1 -g -L 1 " + QDir::homeDirPath() + "/.kports/ports-supfile && echo kports_success";
		
	if (geteuid!=0)
		proc << QStringList::split(' ', "kdesu --caption=KPorts -t -c ");
	else
		proc << "/bin/sh" << "-c";
		
	proc << cmd;
					
	/// write command into the logfile
	QString total(""), temp("");
	QValueList<QCString> stringbu = proc.args();
	for (QValueList<QCString>::iterator it = stringbu.begin(); it != stringbu.end(); ++it)
	{
		temp = *it;
		total += temp + " ";
	}
//	logfile.writeBlock("--> " + proc.args().join(" ") + "\n", proc.argss().join(" ").length() + 5);
		
	/// append this proc to the list of active procs
	activeProcs.append(proc.name());
//	if (setsid()==-1)
//		qDebug("errno = " + QString::number(*__error()));

	proc.start(KProcess::OwnGroup, KProcess::AllOutput); /// ownGroup so children spawned by proc can be killed too + comm=alloutput
	int i = 0;
		
	if (indexExists) /// we have information to calculate progress
	{
	
		while (( i = proc.readln(Buffer, false) >= 0) || (proc.isRunning()))
		{
			/// the output will not be processed/interpreted by this call, but instead
			/// by the gui thread, because that has relevant information neede
	
			
			if (i > 0)	/// there is output
			{
				
				logfile.writeBlock(Buffer + "\n" , Buffer.length()+1); 	/// write it to log
				
				if ( (Buffer.section('/',1, 2) != b2.section('/',1, 2))) /// a different is updated
					counter++;
				
				if (counter = 15) /// we only check on every 15th port for speed reasons
				{
					counter = 0;
					tmpport = portWithOrigin(Buffer.section('/', 1, 2));
					if (tmpport) /// port was found and we get its position in index to find out were we are 
					{
						current = array.at();  /// tmmport should still be current item so we can use at to get the index
					
						tempint = current * 98 / pkgCount;
						if ( (tempint <= 99 ) && (tempint > percent) ) /// we only multiply with 95 insetad of 100 in case the port number increases
							percent = tempint;
							
						if (percent != lastpercent)
							QApplication::postEvent(this, new QMyEvent(1140, percent));
			
							
						lastpercent = percent;
					} ///new ports are ignored
					
				}
				b2 = Buffer;	
			} else	/// insert a delay, without delay kprocio throws SIGABRT
				proc.wait(1);
			
			
			if (toBeStoppedProcs.contains(proc.name()) || toBeStoppedProcs.contains("*")) /// should be interrupted
			{
				proc.kill(SIGINT); /// try to terminate nicely
				if (!proc.wait(2))
					proc.kill(SIGKILL);/// then we kill it
					
				Buffer = "--> Process interrupted by User.\n"; /// get line from output and make it red
				logfile.writeBlock(Buffer, Buffer.length()); 	/// write it to log
				
			}
			
			if (!Buffer.contains("kports_success"))
				Buffer = "";
		}
		
/*		while (!feof(pipe))
		{
			b2 = Buffer;
			fgets( buffer, 400, pipe );
			buffer[400]=0;
			Buffer = buffer;
	
			logfile.writeBlock(Buffer, Buffer.length());
			
			if ( (Buffer.section('/',1, 2) != b2.section('/',1, 2))) /// next port is updated
				counter++;
				
			if (counter = 15) /// we only check on every 15th port for speed reasons
			{
				counter = 0;
				tmpport = portWithOrigin(Buffer.section('/', 1, 2));
				if (tmpport) /// port was found and we get its position in index to find out were we are 
				{
					current = array.at();  /// tmmport should still be current item so we can use at to get the index
				
					tempint = current * 95 / pkgCount;
					if ( (tempint <= 99 ) && (tempint > percent) ) /// we only multiply with 95 insetad of 100 in case the port number increases
						percent = tempint;
						
					if (percent != lastpercent)
						QApplication::postEvent(this, new QCustomEvent((QEvent::Type)1140, ptr));
		
						
					lastpercent = percent;
				} ///new ports are ignored
				
			}
		}*/
	} else /// we just guess that there about 15000 ports (counter actually is the number of processed ports now) -> 150 ~ 1%
	{
//		QMessageBox::information(this, i18n("Kports - Warning"), i18n("Since no INDEX was found the progress shown is only an assumption."));
		counter = 140; ///start value
		/// this vlue must be updated on every new version to reflect the current size of the portstree
		int counter_that_is_1_percent = 150;
		
		while (( i = proc.readln(Buffer, false) >= 0) || (proc.isRunning()))
		{
			/// the output will not be processed/interpreted by this call, but instead
			/// by the gui thread, because that has relevant information neede
	
			
			if (i > 0)	/// there is output
			{
				
				logfile.writeBlock(Buffer + '\n', Buffer.length()+1); 	/// write it to log
		
				if ( (Buffer.section('/',0, 2) != b2.section('/',0, 2)) 
					&& (Buffer.section('/',1, 2).contains('/'))
					&& (!Buffer.section('/',1, 2).startsWith("M"))
					&& (!Buffer.section('/',1, 2).startsWith("T")) ) /// next port is updated
				{
					if ((counter++ % counter_that_is_1_percent == 0)  && (percent<99) )/// time to increase again
					{
						percent++;
						
						QApplication::postEvent(this, new QMyEvent(1140, percent));
										
					}
				}
				
				b2 = Buffer;					/// backup buffer
			} else	/// insert a delay, without delay kprocio throws SIGABRT
				proc.wait(1);

			if (toBeStoppedProcs.contains(proc.name()) || toBeStoppedProcs.contains("*")) /// should be interrupted
			{
				proc.kill(SIGINT); /// try to terminate nicely
				if (!proc.wait(2))
					proc.kill(SIGKILL);/// then we kill it
					
				Buffer = "--> Process interrupted by User."; /// get line from output and make it red
				logfile.writeBlock(Buffer, Buffer.length()); 	/// write it to log
			
			}
			
			if (!Buffer.contains("kports_success"))
				Buffer = "";
		}
		
	}
		
	/*	while (!feof(pipe))
		{
			b2 = Buffer;
			fgets( buffer, 400, pipe );
			buffer[400]=0;
			Buffer = buffer;
	
			logfile.writeBlock(Buffer, Buffer.length());
			
			if ( (Buffer.section('/',0, 2) != b2.section('/',0, 2)) 
				&& (Buffer.section('/',1, 2).contains('/'))
				&& (!Buffer.section('/',1, 2).startsWith("M"))
				&& (!Buffer.section('/',1, 2).startsWith("T")) ) /// next port is updated
			{
				if ((counter++ % counter_that_is_1_percent == 0)  && (percent<99) )/// time to increase again
				{
					percent++;
					
					QApplication::postEvent(this, new QCustomEvent((QEvent::Type)1140, ptr));
									
				}
			}
				
			
		}*/
	
	/// erase it from both lists
	activeProcs.erase(activeProcs.find(proc.name()));	
	while (toBeStoppedProcs.contains(proc.name()))
		toBeStoppedProcs.erase(toBeStoppedProcs.find(proc.name()));
	
	logfile.close();
	
	if (b2.contains("success")) ///everything was successful
	{
		if (!keepLogsForSuccessfulProcs)
			logfile.remove();
			
		QApplication::postEvent(this, new QMyEvent(1140, 100));
		
	} else
	{
		QApplication::postEvent(this, new QMyEvent(1141, logpath));
	}
	
		 
}


void 	QBsdPortGlobal::updateIndex(int build)
{
	
	KProcIO proc;
	proc.setName("updateIndexProc");
	QString	Buffer(""), cmd(""), err("");
	int wait = 0;
	
	///locate and create the logfile
	QString logpath = QDir::homeDirPath() + "/.kports/index-update.log";
	QFile	logfile(logpath);
	if (logfile.exists())
		logfile.remove();
	logfile.open(IO_WriteOnly | IO_Append);
	
	if (build) ///make the index
		cmd = "cd " + portsDir + " && env INDEX_VERBOSE=1 make index && echo kports_success";
	else	/// fetch it
		cmd = "cd " + portsDir + " && make fetchindex && echo kports_success";
		

	
//	proc.setArguments(QStringList::split(' ', "kdesu --caption=KPorts -t -d -c"));
//	proc.addArgument(cmd);
	if (getuid!=0)
		proc << QStringList::split(' ', "kdesu --caption=KPorts -t -c ") << cmd;
	else
		proc << "/bin/sh" << "-c" << cmd;
		
	/// write command into the logfile
	QString total(""), temp("");
	QValueList<QCString> stringbu = proc.args();
	for (QValueList<QCString>::iterator it = stringbu.begin(); it != stringbu.end(); ++it)
	{
		temp = *it;
		total += temp + " ";
	}
	logfile.writeBlock("--> " + total + "\n", total.length() + 5);
	
	/// append this proc to the list of active procs
	activeProcs.append(proc.name());
	
	proc.start(KProcess::OwnGroup, KProcess::AllOutput); /// ownGroup so children spawned by proc can be killed too + comm=alloutput
	
	int i = 0;
		
	while (( i = proc.readln(Buffer, false) >= 0) || (proc.isRunning()) )
	{
		/// the output will not be processed/interpreted by this call, but instead
		/// by the gui thread, because that has relevant information neede

		
		if (i > 0)	/// there is output
		{
//			Buffer.remove('\n');
//			Buffer.remove(QChar(13));
			logfile.writeBlock(Buffer, Buffer.length()); 	/// write it to log
		} else	/// insert a delay, without delay kprocio throws SIGABRT
			proc.wait(1);
		
		
		if (toBeStoppedProcs.contains(proc.name()) || toBeStoppedProcs.contains("*")) /// should be interrupted
		{
			proc.kill(SIGINT); /// try to terminate nicely
			if (!proc.wait(2))
				proc.kill(SIGKILL);/// then we kill it
				
			Buffer = "--> Process interrupted by User."; /// get line from output and make it red
			logfile.writeBlock(Buffer, Buffer.length()); 	/// write it to log
		}
		
	}
	
	/// erase it from both lists
	activeProcs.erase(activeProcs.find(proc.name()));	
	while (toBeStoppedProcs.contains(proc.name()))
		toBeStoppedProcs.erase(toBeStoppedProcs.find(proc.name()));
	
	///close the logfile	
	logfile.close();
			
			
	if  (!Buffer.contains("kports_success")) //|| (((build) && (!gut gemacht))) )
		QApplication::postEvent(this, new QMyEvent(1141, logpath)); /// emit path to logfile
	else
	{
		if (!keepLogsForSuccessfulProcs)
			logfile.remove();

		QApplication::postEvent(this, new QMyEvent(1140, 100)); /// 100%
	}	
			
	
	
/*	
	
	FILE 	*pipe;
	char	buffer[400];
	QString	Buffer(""), cmd("");
	QString *logpath = new QString(QDir::homeDirPath() + "/.kports/index-update.log");
	QFile	logfile(*logpath);
	if (logfile.exists())
		logfile.remove();
	logfile.open(IO_WriteOnly | IO_Append);
		
	int	*ptr = new int;
	*ptr 	= 100;

	if (build)
		cmd = "kdesu --caption=KPorts -t -d -c 'cd " + portsDir + " && env INDEX_VERBOSE=1 make index 2>&1 | tee' 2>&1";
	else
		cmd = "kdesu --caption=KPorts -t -d -c 'cd " + portsDir + " && make fetchindex 2>&1 | tee' 2>&1";
		 
	logfile.writeBlock("--> " + cmd+ "\n", cmd.length() + 5);
		 
	if( (pipe = popen( cmd.latin1(), "r" )) == NULL )
	{
		std::cout << "buhu";
		return;
	}

	while(!feof(pipe))
	{
		fgets(buffer, 400, pipe);
		buffer[399]=0;
		Buffer = buffer;

		logfile.writeBlock(Buffer, Buffer.length());
		

		

	
	}
		
	if  ((!build) && (!Buffer.endsWith(" kBps\n"))) //|| (((build) && (!gut gemacht))) )
		QApplication::postEvent(this, new QCustomEvent((QEvent::Type)1141, logpath)); /// emit path to logfile
	else
		QApplication::postEvent(this, new QCustomEvent((QEvent::Type)1140, ptr)); /// 100%**/


}

void 	QBsdPortGlobal::updatePortsDb()
{
	KProcIO proc;
	QString	Buffer(""), cmd(""), err("");
	int wait = 0;
	
	///locate and create the logfile
	QString logpath = QDir::homeDirPath() + "/.kports/portsdb-update.log";
	QFile	logfile(logpath);
	if (logfile.exists())
		logfile.remove();
	logfile.open(IO_WriteOnly | IO_Append);
	
	cmd = "portsdb -u && echo kports_success";

	
//	proc.setArguments(QStringList::split(' ', "kdesu --caption=KPorts -t -d -c"));
//	proc.addArgument(cmd);
		
	if (getuid!=0)
		proc << QStringList::split(' ', "kdesu --caption=KPorts -t -c ") << cmd;
	else
		proc << "/bin/sh" << "-c" << cmd;
	
	/// write command into the logfile
	/// write command into the logfile
	QString total(""), temp("");
	QValueList<QCString> stringbu = proc.args();
	for (QValueList<QCString>::iterator it = stringbu.begin(); it != stringbu.end(); ++it)
	{
		temp = *it;
		total += temp + " ";
	}
	logfile.writeBlock("--> " + total + "\n", total.length() + 5);
	
	/// append this proc to the list of active procs
	activeProcs.append(proc.name());
	

	proc.start(KProcess::OwnGroup, KProcess::AllOutput); /// ownGroup so children spawned by proc can be killed too + comm=alloutput
	
	int i= 0;
	while (( i = proc.readln(Buffer, false) >= 0) || (proc.isRunning()) )
	{
		/// the output will not be processed/interpreted by this call, but instead
		/// by the gui thread, because that has relevant information neede

		
		if (i > 0)	/// there is output
		{
//			Buffer.remove('\n');
//			Buffer.remove(QChar(13));
			logfile.writeBlock(Buffer, Buffer.length()); 	/// write it to log
		} else	/// insert a delay, without delay kprocio throws SIGABRT
			proc.wait(1);
		
		
		if (toBeStoppedProcs.contains(proc.name()) || toBeStoppedProcs.contains("*")) /// should be interrupted
		{
			proc.kill(SIGINT); /// try to terminate nicely
			if (!proc.wait(2))
				proc.kill(SIGKILL);/// then we kill it
				
			Buffer = "--> Process interrupted by User."; /// get line from output and make it red
			logfile.writeBlock(Buffer, Buffer.length()); 	/// write it to log
		}
		
	}
	
	/// erase it from both lists
	activeProcs.erase(activeProcs.find(proc.name()));	
	while (toBeStoppedProcs.contains(proc.name()))
		toBeStoppedProcs.erase(toBeStoppedProcs.find(proc.name()));
	
	///close the logfile	
	logfile.close();
			
			
	if  ((!Buffer.contains("kports_success"))) /// error during process
		QApplication::postEvent(this, new QMyEvent(1141, logpath)); /// emit path to logfile
	else
	{
		if (!keepLogsForSuccessfulProcs)
			logfile.remove();
			
		QApplication::postEvent(this, new QMyEvent(1140, 100)); /// 100%
	}	




/*
	FILE 	*pipe;
	char	buffer[400];
	QString	Buffer(""), cmd("");
	QString *logpath = new QString(QDir::homeDirPath() + "/.kports/portsdb-update.log");
	QFile	logfile(*logpath);
	if (logfile.exists())
		logfile.remove();
	logfile.open(IO_WriteOnly | IO_Append);
		
	int	*ptr = new int;
	*ptr 	= 0;

	cmd = "kdesu --caption=KPorts -t -d -c 'portsdb -u 2>&1' 2>&1";
		 
	logfile.writeBlock("--> " + cmd+ "\n", cmd.length() + 5);
		 		 
	if( (pipe = popen( cmd.latin1(), "r" )) == NULL )
	{
		std::cout << "buhu";
		return;
	}

	while(!feof(pipe))
	{
		fgets(buffer, 400, pipe);
		buffer[399]=0;
		Buffer = buffer;

		logfile.writeBlock(Buffer, Buffer.length());
		
		if (Buffer.contains("done]"))
		{	
			*ptr = 100;
			QApplication::postEvent(this, new QCustomEvent((QEvent::Type)1140, ptr));
		}
	}
			
	if (*ptr != 100)
		QApplication::postEvent(this, new QCustomEvent((QEvent::Type)1141, logpath));*/
}


void 	QBsdPortGlobal::install_port(QBsdPort* Port, int Aim, int Recursive, int BinSource, bool Ignore, QString Env)
{

	/** make the command **/
	QString cmd = "";
	
	cmd.reserve(400);

//	Env +=" TERM=xterm SHLVL=1 ";


	switch (platform.pkgsystem)
	{
		case -1:{
			
			
			if (BinSource) /// binary-only
			{
				/// upgrade equals reinstall of higher version
				/// downgrade equals reinstall of lower version
				/// reinstall is delete and then frsh install
				if (Aim!=0)
					cmd += "pkg_delete -v -f " + Port->installed()->name() + "-" + Port->installed()->version() + " && ";

				if (Env.startsWith("PREFIX="))
					cmd += "pkg_add -P " + Env.remove(0,7) + " -v "; /// we remove PREFIX= from the var
				else
					cmd += "pkg_add -v ";

				if (Ignore)
					cmd += "-f ";
				cmd += pkgSite +"../All/" + Port->avBinary()->name() + Port->avBinary()->version();
				cmd += " 2>&1' 2>&1";
			} else	/// source-only
			{
				if (Aim!=0)
					cmd += "pkg_delete -v -f " + Port->installed()->name() + "-" + Port->installed()->version() + " && ";
				
				cmd += "cd " + portsDir + Port->origin() + " && ";
				if (Env!="")
					cmd += "env BATCH=1 " + Env + " make install clean";
				else
					cmd += "env BATCH=1 make install clean";

			}
		       }break;
		case 0:{
			cmd += "env BATCH=1 DISABLE_VULNERABILITIES=1 PACKAGESITE=" + pkgSite + " ";
			if (Env!="")
				cmd += Env + " ";
			switch(Aim)	/// see description in bsdport.h
			{
				case 0:/// fresh install
					cmd += "portupgrade -v -y -N ";
					break;
				case 1:/// upgrade
					cmd += "portupgrade -v -y -N ";
					break;
				case 2:/// downgrade equals reinstall of lower version
				case 3:/// reisntall (-> force flag)
					cmd += "portupgrade -v -y -f -N ";
					break;
				default:
					qDebug("wrong switch!?");
					return;
			}

			if (BinSource==1) /// binary-only (0 needs no options)
				cmd += "-PP ";
			else if (BinSource==2) /// binary, but source if source version unequals binary
				cmd += "-P ";
		
			if (Ignore)	/// Ignore erros (->keep going flag)
				cmd += "-k ";
			
			if (Recursive==1)
				cmd += "-r ";/// act on dependencies
			else if (Recursive==2)
				cmd += "-R ";/// act on requiremtns
			else if (Recursive==3)
				cmd += "-r -R "; /// do both
				
//			cmd += "-L /home/hannes/.kports/megalog ";
					
			if (Aim!=0)
				cmd += Port->installed()->name() + "-" + Port->installed()->version(); /// name and installed version
			else
				cmd += Port->origin(); /// for fresh installs we may specify portorigin
			


		       }break;
		default:
			qDebug("PLATFORM NOT (YET) SUPPORTED");
			return;
			break;
	}

	/** create Proc **/
	
	KProcIO proc; 
	
	proc.setName("installProc");
	
	while (toBeStoppedProcs.contains(proc.name())) 	/// make sure no old stuff stop us now ;)
		toBeStoppedProcs.erase(toBeStoppedProcs.find(proc.name()));
	
	if (getuid!=0)
		proc << QStringList::split(' ', "kdesu --caption=KPorts -t -c ") << cmd;
	else
		proc << "/bin/sh" << "-c" << cmd;

	
	QApplication::postEvent(this, new QMyEvent(1199, cmd));	/// signal it out
	

	QString	Buffer(""), err("");
	
	
	/// append this proc to the list of active procs
	activeProcs.append(proc.name());
	
	proc.enableReadSignals(false);
	proc.setComm(KProcess::AllOutput);
	proc.start(KProcess::OwnGroup, true); /// ownGroup so children spawned by proc can be killed too + comm=alloutput

	/// to prevent queueing of messages we start a timer
//	QTimer *timer = new QTimer(this);
//	connect( timer, SIGNAL(timeout()), this, SLOT(postAllEvents()) );
	
//	timer->start(1000);
	int i = 0;
	
//	qDebug("kports pid: " + QString::number(getpid()) + " gid: " + QString::number(getpgrp()) +
//		"\nprocs pid: " + QString::number(proc.pid()) + " gid: " + QString::number(getpgid(proc.pid())));
	
	
	while (((i = proc.readln(Buffer, false)) >= 0) || (proc.isRunning()))
	{
		/// the output will not be processed/interpreted by this call, but instead
		/// by the gui thread, because that has relevant information neede

		if (i > 0)	/// there is output
		{
			if (!Buffer.contains("Broken pipe"))
			{
				Buffer.remove('\n');
				Buffer.remove(QChar(13));
//				qDebug("Buffer: "+Buffer +" length: " +QString::number(Buffer.length()));
				QApplication::postEvent(this, new QMyEvent(1200, Buffer));	/// signal it out
			}
		} else	/// insert a delay, without delay kprocio throws SIGABRT
			proc.wait(1);
		
		
		if (toBeStoppedProcs.contains(proc.name()) || toBeStoppedProcs.contains("*")) /// should be interrupted
		{
			
			proc.kill(SIGINT); /// try to terminate nicely
			if (!proc.wait(3))
				proc.kill(SIGTERM);/// then we kill it
			if (!proc.wait(3))
				proc.kill(SIGKILL);/// then we kill it
				
			Buffer = "--> Process interrupted by User."; /// get line from output and make it red
			QApplication::postEvent(this, new QMyEvent(1200, Buffer));	/// signal it out
		
			proc.wait(1);
		}
		
		Buffer = "";
		

		
	}

	/// erase it from both lists
	activeProcs.erase(activeProcs.find(proc.name()));	
	while (toBeStoppedProcs.contains(proc.name()))
		toBeStoppedProcs.erase(toBeStoppedProcs.find(proc.name()));

	QApplication::postEvent(this, new QCustomEvent(1202));	/// signal it out	
		


}

void QBsdPortGlobal::postAllEvents()
{
//	qDebug("sending all events");
	QApplication::sendPostedEvents();
}

void QBsdPortGlobal::uninstall_port(QBsdPort* Port, int Recursive, bool Ignore)
{

	/** make the command the will be run **/
	QString cmd = "";
	
	cmd.reserve(400);

	if ( (platform.pkgsystem==-1) && (Recursive>1) )
		Recursive=1;	// -R flag only available with pkg_deinstall

	
	switch(platform.pkgsystem)	//see description in bsdport.h
	{
		case -1:
			cmd += "pkg_delete -v ";
			
			if (Recursive!=0)
				cmd += "-r "; //Recursive
			if (Ignore)
				cmd += "-f ";

			break;
		case 0:
			cmd += "pkg_deinstall -v ";

			if (Recursive==1)
				cmd += "-r ";//Recursive
			else if (Recursive==2)
				cmd += "-R ";//upward-Recursive
			else if (Recursive==3)
				cmd += "-r -R ";
			if (Ignore)
				cmd += "-f ";

			break;

		default:
			qDebug("PLATFORM NOT (YET) SUPPORTED");
			return;
	}		
	
	cmd += Port->installed()->name() + "-" + Port->installed()->version();


	KProcIO proc; 

	proc.setName("uninstallProc");
	
	while (toBeStoppedProcs.contains(proc.name())) 	/// make sure no old stuff stop us now ;)
		toBeStoppedProcs.erase(toBeStoppedProcs.find(proc.name()));
	
	if (geteuid!=0)
		proc << QStringList::split(' ', "kdesu --caption=KPorts -t -c ") << cmd;
	else
		proc << "/bin/sh" << "-c" << cmd;

	
	QApplication::postEvent(this, new QMyEvent(1199, cmd));	/// signal it out
	

	QString	Buffer(""), err("");
	
	
	/// append this proc to the list of active procs
	activeProcs.append(proc.name());
	
	proc.enableReadSignals(false);
	proc.setComm(KProcess::AllOutput);
	proc.start(KProcess::OwnGroup, true); /// ownGroup so children spawned by proc can be killed too + comm=alloutput

	/// to prevent queueing of messages we start a timer
//	QTimer *timer = new QTimer(this);
//	connect( timer, SIGNAL(timeout()), this, SLOT(postAllEvents()) );
	
//	timer->start(1000);
	int i = 0;
	
//	qDebug("kports pid: " + QString::number(getpid()) + " gid: " + QString::number(getpgrp()) +
//		"\nprocs pid: " + QString::number(proc.pid()) + " gid: " + QString::number(getpgid(proc.pid())));
	
	
	while (((i = proc.readln(Buffer, false)) >= 0) || (proc.isRunning()))
	{
		/// the output will not be processed/interpreted by this call, but instead
		/// by the gui thread, because that has relevant information neede

		if (i > 0)	/// there is output
		{
			if (!Buffer.contains("grep: writing output: Broken pipe"))
			{
				Buffer.remove('\n');
				Buffer.remove(QChar(13));
//				qDebug("Buffer: "+Buffer +" length: " +QString::number(Buffer.length()));
				QApplication::postEvent(this, new QMyEvent(1200, Buffer));	/// signal it out
			}
		} else	/// insert a delay, without delay kprocio throws SIGABRT
			proc.wait(1);
		
		
		if (toBeStoppedProcs.contains(proc.name()) || toBeStoppedProcs.contains("*")) /// should be interrupted
		{
			
			proc.kill(SIGINT); /// try to terminate nicely
			if (!proc.wait(3))
				proc.kill(SIGTERM);/// then we kill it
			if (!proc.wait(3))
				proc.kill(SIGKILL);/// then we kill it
				
			Buffer = "--> Process interrupted by User."; /// get line from output and make it red
			QApplication::postEvent(this, new QMyEvent(1200, Buffer));	/// signal it out
		
			proc.wait(1);
		}
		
		Buffer = "";
		

		
	}

	/// erase it from both lists
	activeProcs.erase(activeProcs.find(proc.name()));	
	while (toBeStoppedProcs.contains(proc.name()))
		toBeStoppedProcs.erase(toBeStoppedProcs.find(proc.name()));

	QApplication::postEvent(this, new QCustomEvent(1202));	/// signal it out	
		
}




void	QBsdPortGlobal::stopProc(QString Name)
{
		
	if (!toBeStoppedProcs.contains(Name))
		toBeStoppedProcs.append(Name);


}

bool	QBsdPortGlobal::becomeRoot()
{
	if (getuid() != 0)
		return 0;
		
	seteuid(0);
		
	return 1;
}

bool	QBsdPortGlobal::becomeUser()
{
	if (getuid() != 0)
		return 0;
		
	seteuid(ui_user_id);

	return 1;
}


void	QBsdPortGlobal::T_findAllAvailableSrc()
{
	T_function *thread = new T_function(&QBsdPortGlobal::findAllAvailableSrc, 0);
//	connect(thread, SIGNAL(finished()), this, SIGNAL(T_findAllAvailableSrcFinished()));
	thread->start();
}
void	QBsdPortGlobal::T_findAllInstalled()
{
	T_function *thread = new T_function(&QBsdPortGlobal::findAllInstalled, 1);
//	connect(&thread, SIGNAL(finished()), this, SIGNAL(T_findAllInstalledFinished()));
	thread->start();
}

void	QBsdPortGlobal::T_findAllAvailableBin()
{
	T_function *thread = new T_function(&QBsdPortGlobal::findAllAvailableBin, 2);
//	connect(&thread, SIGNAL(finished()), this, SIGNAL(T_findAllAvailableBinFinished()));
	thread->start();
}
void	QBsdPortGlobal::T_readUpdFile()
{
	T_function *thread = new T_function(&QBsdPortGlobal::readUpdFile, 3);
//	connect(&thread, SIGNAL(finished()), this, SIGNAL(T_readUpdFileFinished()));
	thread->start();
}
void	QBsdPortGlobal::T_findVulnas()
{
	T_function *thread = new T_function(&QBsdPortGlobal::findVulnas, 4);
//	connect(&thread, SIGNAL(finished()), this, SIGNAL(T_findVulnasFinished()));
	thread->start();
}
void	QBsdPortGlobal::T_updateVulnaDb()
{
	T_function *thread = new T_function(&QBsdPortGlobal::updateVulnaDb, 5);
//	connect(&thread, SIGNAL(finished()), this, SIGNAL(T_saveMemoryFinished()));
	thread->start();
}

void	QBsdPortGlobal::T_search(QString Term, int Criterium, bool Exact)
{
	T_function *thread = new T_function(&QBsdPortGlobal::searchFrame, 6, Term, Criterium, Exact);
//	connect(&thread, SIGNAL(finished()), this, SIGNAL(T_saveMemoryFinished()));
	thread->start();
}

void	QBsdPortGlobal::T_updatePortsDir()
{
	T_function *thread = new T_function(&QBsdPortGlobal::updatePortsDir, 7);
//	connect(&thread, SIGNAL(finished()), this, SIGNAL(T_saveMemoryFinished()));
	thread->start();
}

void	QBsdPortGlobal::T_updateIndex(int build)
{
	T_function *thread = new T_function(&QBsdPortGlobal::updateIndex, 8, build);
//	connect(&thread, SIGNAL(finished()), this, SIGNAL(T_saveMemoryFinished()));
	thread->start();
}

void	QBsdPortGlobal::T_updatePortsDb()
{
	T_function *thread = new T_function(&QBsdPortGlobal::updatePortsDb, 9);
//	connect(&thread, SIGNAL(finished()), this, SIGNAL(T_saveMemoryFinished()));
	thread->start();
}

void	QBsdPortGlobal::T_install_port(QBsdPort* Port, int Aim, int Recursive, int BinSource, bool Ignore, QString Env)
{
	T_function *thread = new T_function(&QBsdPortGlobal::install_port, 10, Port, Aim, Recursive, BinSource, Ignore, Env);
//	connect(&thread, SIGNAL(finished()), this, SIGNAL(T_saveMemoryFinished()));
	thread->start();
}

void	QBsdPortGlobal::T_uninstall_port(QBsdPort* Port, int Recursive, bool Ignore)
{
	T_function *thread = new T_function(&QBsdPortGlobal::uninstall_port, 11, Port, Recursive, Ignore);
//	connect(&thread, SIGNAL(finished()), this, SIGNAL(T_saveMemoryFinished()));
	thread->start();
}





/** ------ class QBsdPort  ----------**/
void QBsdPort::findInstalled()
{

	 //! WARNING UNTESTED CODE
	 
	FILE 	*pipe;
	QString cmd="";
	char 	buffer[250]="";
	int	ident=0;	/// says which content, a line belongs to (for content that goes over many lines)
				/// if you dont understand this, look at "pkg_info -pcdDrRLso 'pkgname'" !!
	QString originbuf(""), depbuf(""), reqbuf(""), descrbuf(""), filebuf(""), messagebuf(""), temp("");
	filebuf.reserve(10000);
	QBsdPortInstPkg *newInstPkg = 0;

	cmd	=  "pkg_info -pcdDrRLso -l \"<|>\" `pkg_info -qO " + origin() + "` 2>&1" ; /// get all the infos, added "<|>" to distinguish  text
	
	if( (pipe = popen( cmd.latin1(), "r" )) == NULL )
	{
		std::cout << "buhu";
		return;
	}


	while (!feof(pipe))
	{
		fgets( buffer, 250, pipe );
		buffer[249]=0;
		temp = buffer;
		temp.remove('\n');///remove std::endline
//		std::std::cout << temp.latin1() <<endl;
		if (temp.startsWith("<|>")) /// a new information section has begun
		{
			temp.remove(0,3); /// remove the cool signs i added
			ident = 0;
		
			if (temp.startsWith("Information for"))
			{
				temp.remove(temp.length()-1,1);	///remove colon

				newInstPkg = new QBsdPortInstPkg();
				newInstPkg->setVersion(temp.section(' ',2,2).section('-',-1,-1));
				newInstPkg->setName(temp.section(' ',2,2).section('-',0,-2));
	
			} else if (temp.startsWith("Comment:"))
				ident = 1;
			else if (temp.startsWith("Depends on:"))
				ident = 2;
			else if (temp.startsWith("Required by:"))
				ident = 3;
			else if (temp.startsWith("Description:"))
				ident = 4;
			else if (temp.startsWith("Install notice:"))
				ident = 5;
			else if (temp.startsWith("Prefix(s):"))
				ident = 6;
			else if (temp.startsWith("Files:"))
				ident = 7;
			else if (temp.startsWith("Package Size:"))
				ident = 8;
			else if (temp.startsWith("Origin:"))
				ident = 9;

		} else if ( (temp!="") || ((ident==4) || (ident==5)) ) /// only 4 +5 have empty lines 
			switch (ident)
			{
				case 1: newInstPkg->setComment(temp); break;
				case 2: temp.remove(0,12);	///remove the "Dependency: "
					reqbuf += " " + temp; break;
				case 3: depbuf	+= " " + temp; break;
				case 4: descrbuf+= temp;
					if (temp.startsWith("WWW:")) /// webpage is part of descr
					{
						temp.remove(0,5);
						newInstPkg->setWWW(temp);
					}
					break;
				case 5: messagebuf += temp; break;
				case 6: if (temp!="\tCWD to .")
					{
						temp.remove(0,8);	/// remove the "(tab)CWD to "
						newInstPkg->setPrefix(temp);
					}
					break;
				case 7: filebuf += temp + "|"; break;
				case 8: newInstPkg->setSize(temp.section("\t",0,0).toULong()); break;
				case 9: originbuf = temp; break;
				default: break;
	
			}

	}

	pclose(pipe);

	if (!newInstPkg)	/// no installed version found
	{
		setInstalled(0);
		return;
	}

	if (avSource()) /// we will now save memory -> QbsdPortPkg in .h for details
	{
		if (avSource()->descr() == descrbuf)
			newInstPkg->setDescr("s");
		else
			newInstPkg->setDescr(descrbuf);
		if (avSource()->reqs() == reqbuf)
			newInstPkg->setReqs("s");
		else
			newInstPkg->setReqs(reqbuf);
		if (avSource()->files() == filebuf)
			newInstPkg->setFiles("s");
		else
			newInstPkg->setFiles(filebuf);
		/// the following have already been saved
		if (avSource()->comment() == newInstPkg->comment())
			newInstPkg->setComment("s");
		if (avSource()->name() == newInstPkg->name())
			newInstPkg->setName("s");
		if (avSource()->version() == newInstPkg->version())
			newInstPkg->setVersion("s");
		if (avSource()->prefix() == newInstPkg->prefix())
			newInstPkg->setPrefix("s");
		if (avSource()->www() == newInstPkg->www())
			newInstPkg->setWWW("s");

		newInstPkg->setDeps(depbuf);
		newInstPkg->setMessage(messagebuf);
//		newInstPkg->setSize(0); /// size is detected later for speed reasons
//		newInstPkg->setFalseFiles("no_init"); /// same reason
		
	} else
	{
		newInstPkg->setDescr(descrbuf);
		newInstPkg->setReqs(reqbuf);
		newInstPkg->setDeps(depbuf);
		newInstPkg->setMessage(messagebuf);
		newInstPkg->setFiles(filebuf);
//		newInstPkg->setSize(0); /// size is detected later for speed reasons
//		newInstPkg->setFalseFiles("no_init"); /// same reason
	}
	
	/// get size in background
	newInstPkg->T_findSize();
	/// find false files in background
	newInstPkg->T_findFalseFiles();

	setInstalled(newInstPkg);
}

void QBsdPort::findAvSource()
{
//! WARNING UNTESTED CODE
	/*information retreived with make describe
		0: name and scrversion
		1: scrpath
		2: prefix
		3: info
		4: path of long descr
		5: maint
		6: categories
		7: some kind of deps(ignored)
		8: some kind of deps(ignored)
		9:some kind of deps(ignored)
		10:build deps
		11:run deps
		12:www
	*/


	FILE 	*pipe;
	QString cmd="";
	QString temp,temp2,temp3;
	QStringList tmp="";
	char 	buffer[2500]="";


	cmd	=  "cd " + global->portsDir + origin() + " && make describe 2>&1";
	
	if( (pipe = popen( cmd.latin1(), "r" )) == NULL )
	{
		std::cout << "buhu";
		return;
	}

	fgets( buffer, 2499, pipe );
	buffer[2499]=0;

	pclose(pipe);

	temp = buffer;

	QBsdPortAvSrcPkg *newAvSource = new QBsdPortAvSrcPkg();
 
	newAvSource->setName((temp.section('|', 0,0)).section('-', 0,-2));
	newAvSource->setVersion((temp.section('|', 0,0)).section('-', -1,-1));
	newAvSource->setPrefix(temp.section('|', 2,2));
	newAvSource->setComment(temp.section('|', 3,3));
	newAvSource->setMaint(temp.section('|', 5,5));
	newAvSource->setCategories(temp.section('|', 6,6));
	QString dep = temp.section('|', 10,10); 
	/// add those builddeps to 'dep' that arent already there
	/// because they are also run deps
	dep += " "; /// add an extra space so build deps may be seperated from rundeps again
	tmp = QStringList::split(' ', temp.section('|', 11,11));	
	for ( QStringList::Iterator it = tmp.begin(); it != tmp.end(); it++ )
		if (!dep.contains(*it))
			dep+= " " + *it;
	newAvSource->setReqs(dep);
	newAvSource->setWWW(temp.section('|', 12,12));

//	if (avSource())
//		delete m_avSource;

	setAvSource(newAvSource);

	/// get rest of info in seperate threads
	newAvSource->T_findDescr();
	newAvSource->T_findOptions();
	newAvSource->T_findFiles();

}

void	QBsdPort::findAvBinary()
{
//! WARNING UNTESTED CODE
	// kommt noch

}


void	QBsdPort::T_findInstalled()
{
	T_function *thread = new T_function(this, &QBsdPort::findInstalled, 0);
//	connect(thread, SIGNAL(finished()), this, SIGNAL(T_findInstalledFinished()));
	thread->start();
}
void	QBsdPort::T_findAvBinary() 
{
	T_function *thread = new T_function(this, &QBsdPort::findAvBinary, 2);
//	connect(thread, SIGNAL(finished()), this, SIGNAL(T_findAvBinaryFinished()));
	thread->start();
}
void	QBsdPort::T_findAvSource()
{
	T_function *thread = new T_function(this, &QBsdPort::findAvSource, 1);
//	connect(thread, SIGNAL(finished()), this, SIGNAL(T_findAvSourceFinished()));
	thread->start();
}

void	QBsdPort::setInstalled(QBsdPortInstPkg *newValue)	
{
	if (installed()) /// delete old contents
		delete m_installed;
	m_installed = newValue;
	if (installed()) /// make sure child's parent point actually points hither
		installed()->setParent(this);
}
void	QBsdPort::setAvSource(QBsdPortAvSrcPkg *newValue)
{ 
	if (avSource()) /// delete old contents
		delete m_avSource;
	m_avSource = newValue;
	if (avSource()) /// make sure child's parent point actually points hither
		avSource()->setParent(this);
}
void	QBsdPort::setAvBinary(QBsdPortAvBinPkg *newValue)
{
	if (avBinary()) /// delete old contents
		delete m_avBinary;
	m_avBinary = newValue;
	if (avBinary()) /// make sure child's parent point actually points hither
		avBinary()->setParent(this);
}

/**------- class QBsdPortPkg ------------**/
QString QBsdPortPkg::version() const	{ if (m_version=="s")	return parent()->avSource()->version();	else return m_version; }
QString QBsdPortPkg::name() const	{ if (m_name=="s")	return parent()->avSource()->name();	else return m_name; }
QString QBsdPortPkg::files() const	{ if (m_files=="s")	return parent()->avSource()->files();	else return m_files; }
QString QBsdPortPkg::reqs() const	{ if (m_reqs=="s")	return parent()->avSource()->reqs();	else return m_reqs; }
QString QBsdPortPkg::vulna() const	{ if (m_vulna=="s")	return parent()->avSource()->vulna();	else return m_vulna; }
QString QBsdPortPkg::prefix() const	{ if (m_prefix=="s")	return parent()->avSource()->prefix();	else return m_prefix; }
QString QBsdPortPkg::comment() const	{ if (m_comment=="s")	return parent()->avSource()->comment(); else return m_comment; }
QString QBsdPortPkg::descr() const	{ if (m_descr=="s")	return parent()->avSource()->descr();	else return m_descr; }
QString QBsdPortPkg::www() const	{ if (m_www=="s")	return parent()->avSource()->www();	else return m_www; }

void QBsdPortPkg::findVulna() /// this call is the same for all subclasses
{
	FILE 	*pipe;
	char 	buffer[400]="";
	QString cmd, temp, result;
//	int	index=-1;
	
	cmd = "portaudit " + name()+ "-" + version() + " 2>&1";
//	std::cout << "secheck: cmd: " << cmd << std::endl;
 
	if( (pipe = popen( cmd.latin1(), "r" )) == NULL )
	{
		std::cout <<"buhu";
		return;
	}

	
	fgets( buffer, 250, pipe );
	buffer[249]=0;
	temp = buffer;
	temp.remove(temp.length()-1,1);
//	std::cout << "secheck: zeile 1 : " << temp.latin1() << std::endl;

	if (temp.startsWith("portaudit: Database"))
	{
		QApplication::postEvent(QBsdPort::global, new QCustomEvent(1111));
		result = "no_init";		/// reset result, so it will be reloaded after db is updated
	} else if (temp.startsWith("0 problem"))
	{
		result = "";
	} else
	{
		result = "";
		while (!feof(pipe))
		{
			fgets( buffer, 250, pipe );
			buffer[249]=0;
			temp = buffer;
			temp.remove(temp.length()-1,1);
	//		std::cout << "secheck: zeile 2 : " << temp.latin1() << std::endl;
			if (temp.startsWith("Type of problem:"))
			{
				temp.remove(0, 17);
				result += "\n" + temp; /// we need a second seperator that is not | if a package has multiple vulnas
			
			
				fgets( buffer, 399, pipe );
				buffer[398]=0;
				temp = buffer;
				temp.remove(temp.length()-2,2); /// remove th > at end of line
		//		std::cout << "secheck: zeile 3: " << temp.latin1() << std::endl;
				if (temp.startsWith("Reference:"))
				{
					temp.remove(0, 12);
					result += "|" + temp;
				}
			}
			
		}
	}
	
	setVulna(result);

	pclose(pipe);
}

/**------- class QBsdPortInstPkg --------**/
void QBsdPortInstPkg::findFalseFiles()
{
	char 	buffer[400]="";
	QString Buffer, cmd, temp, result;
//	int	index=-1;
	FILE	*pipe;	

	cmd = "pkg_info -qg " + name()+ "-" + version() + " 2>&1";

	if( (pipe = popen( cmd.latin1(), "r" )) == NULL )
	{
		std::cout <<"buhu";
		return;
	}

	result = "|";
	while (!feof(pipe))
	{
		fgets(buffer, 400, pipe);
		Buffer = buffer;
		Buffer.remove(Buffer.length()-1,1); /// remove std::endline
		if (Buffer.startsWith("pkg_info:") && Buffer.endsWith("exist")) /// file doesnt exist
		{
			Buffer = Buffer.section(' ', 1, 1); /// get the path
			result += Buffer + "!|"; /// missing files get an extra exclamation mark

		} else if (Buffer.startsWith("/") && Buffer.endsWith("checksum")) /// checksum mismatch
		{
			Buffer = Buffer.section(' ', 0, 0); /// get the path
			result += Buffer + "|";
		}

	}

	if (result=="|")
		result = "";

	setFalseFiles(result);

	pclose(pipe);

}

void QBsdPortInstPkg::findSize()
{
	char buffer[100];
	QString cmd, Buffer;
	FILE* pipe;

	cmd = "pkg_info -qs " + name()+ "-" + version() + " 2>&1";

	if( (pipe = popen( cmd.latin1(), "r" )) == NULL )
	{
		std::cout <<"buhu";
		return;
	}

	fgets(buffer, 400, pipe);
	Buffer = buffer;
	Buffer.remove(Buffer.length()-1,1); /// remove std::endline

	setSize(Buffer.toULong());

	pclose(pipe);

}

void QBsdPortInstPkg::exportPkg(QString dest_file)
{
	/// pkg_create -Yy -b "name()-version()" "output-filename"
	char buffer[100];
	QString cmd, Buffer, log;
	FILE* pipe;

	cmd = "pkg_create -Yy -b " + name()+ "-" + version() + " \"" + dest_file + "\" 2>&1";

	if( (pipe = popen( cmd.latin1(), "r" )) == NULL )
	{
		std::cout <<"buhu";
		return;
	}

	while (!feof(pipe))
	{
		fgets(buffer, 400, pipe);
		Buffer = buffer;
		
		log += Buffer;
		
	}
	pclose(pipe);	
	
	if (QFile::exists(dest_file))
		QApplication::postEvent(this, new QCustomEvent(1100));
	else
	{
		QApplication::postEvent(this, new QMyEvent(1101, log));
	}	

}
/*-------- class QBsdPortAvBinPkg---------
QString QBsdPortAvBinPkg::version() const { if (m_version=="s")	return parent()->avSource()->version();	else return m_version; }
QString QBsdPortAvBinPkg::name() const	{ if (m_name=="s")	return parent()->avSource()->name();	else return m_name; }
QString QBsdPortAvBinPkg::files() const	{ if (m_files=="s")	return parent()->avSource()->files();	else return m_files; }
QString QBsdPortAvBinPkg::reqs() const	{ if (m_reqs=="s")	return parent()->avSource()->reqs();	else return m_reqs; }
QString QBsdPortAvBinPkg::vulna() const	{ if (m_vulna=="s")	return parent()->avSource()->vulna();	else return m_vulna; }
QString QBsdPortAvBinPkg::prefix() const { if (m_prefix=="s")	return parent()->avSource()->prefix();	else return m_prefix; }
QString QBsdPortAvBinPkg::comment() const { if (m_comment=="s")	return parent()->avSource()->comment(); else return m_comment; }
QString QBsdPortAvBinPkg::descr() const	{ if (m_descr=="s")	return parent()->avSource()->descr();	else return m_descr; }
QString QBsdPortAvBinPkg::www() const	{ if (m_www=="s")	return parent()->avSource()->www();	else return m_www; }*/
/**-------- class QBsdPortAvSrcPkg---------**/
void QBsdPortAvSrcPkg::findFiles()
{


	QString temp(""), Buffer;
	temp.reserve(400);

	QFile file(QBsdPort::global->portsDir + parent()->origin() + "/pkg-plist");

//	std::cout << file.name()<<endl;
	if (file.exists())
	{

		file.open(IO_ReadOnly);
	
		while (!file.atEnd())
		{
			file.readLine(Buffer, 200);
	//		std::cout << "buffer:" << buffer;
			if (!Buffer.contains("@"))
			{
				if (Buffer.contains("%%DATADIR%%")) /// replace vars
					Buffer.replace("%%DATADIR%%", "share/" + name() + "/");
					///TODO: this needs to be reworked cleanly so that prefix and datadir are detected that replaced
				temp += "|" + Buffer;
			}
	
		}
		
		file.close();
		
	} else
	{
	
		FILE 	*pipe;
		char	buffer[400]="";
		QString	Buffer, cmd;
		
		cmd = "cd " + QBsdPort::global->portsDir + parent()->origin() + " && make -V PLIST_FILES 2>&1";
		
		if( (pipe = popen( cmd.latin1(), "r" )) == NULL )
		{
			std::cout << "buhu";
			return;
		}
	
		while(!feof(pipe))
		{
			fgets( buffer, 350, pipe );  
			Buffer = buffer;
			Buffer.remove(Buffer.length()-1,1);
			
			if (Buffer.contains(" "))
			{
				QStringList list = QStringList::split(" ", Buffer);
				QString tmp("");
				for ( QStringList::Iterator it = list.begin(); it != list.end(); ++it)
					temp += "|" + *it;
					
			} else	if (!Buffer.contains("@"))
			{
				if (Buffer.contains("%%DATADIR%%")) /// replace vars
					Buffer.replace("%%DATADIR%%", "share/" + name());
					///TODO: this needs to be reworked cleanly so that prefix and datadir are detected that replaced
				temp += "|" + Buffer;
			}
		}
		pclose(pipe);
	}		
			
	setFiles(temp);	
}

void QBsdPortAvSrcPkg::findDescr()
{
	QString temp, buffer;
	temp.reserve(400);

	QFile file(QBsdPort::global->portsDir + parent()->origin() + "/pkg-descr");

//	std::cout << file.name()<<endl;
	if (!file.exists())
		return;

	file.open(IO_ReadOnly);

	while (!file.atEnd())
	{
		file.readLine(buffer, 200);
//		std::cout << "buffer:" << buffer;
		//remove the std::endline if last character was not a '.' ':' or '!'
		//kports wants consistent text not lines
/*		if ( (buffer.length()>1)
		  && (buffer[buffer.length()-2] !='.') 
		  && (buffer[buffer.length()-2] !=':')
		  && (buffer[buffer.length()-2] !=';')
		  && (buffer[buffer.length()-2] !='?')
		  && (buffer[buffer.length()-2] !='!') )		
		{
			if (buffer[buffer.length()-2]!=' ')
				buffer[buffer.length()-1]=' ';
			else
				buffer.remove(buffer.length()-1,1);
		}*/
		temp += buffer;

	}
	
	file.close();

	setDescr(temp);

}

void QBsdPortAvSrcPkg::findFlags()
{
	/// find out whether package is marked as broken, ignor or whatever

	FILE 	*pipe;
	char 	buffer[250]="";
	QString Buffer, final, cmd;
	
	for (int i = 0; i<5; i++)
	{
		cmd = "cd " + QBsdPort::global->portsDir + parent()->origin() + " && make -V ";
		
		switch(i)
		{
			case 0: cmd += "IGNORE 2>&1"; break;
			case 1: cmd += "RESTRICTED 2>&1"; break;
			case 2: cmd += "BROKEN 2>&1"; break;
			case 3: cmd += "FORBIDDEN 2>&1"; break;
			case 4: cmd += "DEPRECATED 2>&1"; break;
		}
			
	
		if( (pipe = popen( cmd.latin1(), "r" )) == NULL )
		{
			std::cout << "buhu";
			return;
		}
	
		fgets( buffer, 250, pipe );  
		Buffer = buffer;
		Buffer.remove(Buffer.length()-1,1);
		
		pclose(pipe);
		
		switch(i)
		{
			case 0: setIgnore(Buffer); break;
			case 1: setRestricted(Buffer); break;
			case 2: setBroken(Buffer); break;
			case 3: setForbidden(Buffer); break;
			case 4: setDeprecated(Buffer); break;
		}
	}
		

}

void QBsdPortAvSrcPkg::findOptions()
{
	/// make  -V OPTIONS
	FILE 	*pipe;
	char	buffer[800]="";
	QString	Buffer, cmd;
	
	cmd = "cd " + QBsdPort::global->portsDir + parent()->origin() + " && make -V OPTIONS 2>&1";
	
	if( (pipe = popen( cmd.latin1(), "r" )) == NULL )
	{
		std::cout << "buhu";
		return;
	}

	fgets( buffer, 800, pipe );  
	Buffer = buffer;
	Buffer.remove(Buffer.length()-1,1);
	
	if (!Buffer.contains("off") && !Buffer.contains("on")) /// check if there are any options
		Buffer = "";
	
	if (Buffer!="")
	{
		/// OPTIONS are in the form    IDENTIFIER "description" defaultstate  IDENTIFIER aso
		/// we use | as seperator inside an option 
		Buffer.replace(" \"", "|");
		Buffer.replace("\" ", "|");
		/// and newline as seperator between options
		Buffer.replace("  ", "\n ");
	}
	pclose(pipe);
	setOptions(Buffer);
}

void QBsdPortAvSrcPkg::exportPkg()
{
	/// make Package

}
/*

void QMyProc::stop()
{	

	m1.lock();
	
	uint gid = getpgid(0);
	int var = -1, i = 0;
	while ( (var == -1) && (++i<6) )
		var = setpgid(0, gid+rand()%1000+33);
		
	if (var == -1)
		qDebug("errno = " + QString::number(*__error()));
		
	KMessageBox::information(KPortsView::mainWnd, "this' pid:" + QString::number(getpid()) + "\tthis' gpid:" + QString::number(getpgid(getpid()))
							+ "\nprocs pid:" + QString::number(processIdentifier()) + "\tproc's gpid:" + QString::number(getpgid(processIdentifier())));
	
	killpg(getpgid(processIdentifier()), SIGTERM);

	sleep(2);
	if (isRunning())
		killpg(getpgid(processIdentifier()), SIGKILL);
		
	
	qDebug("rcksetz = " + QString::number(setpgid(0, gid)));
			

		
	m1.unlock();
}
*/