/***************************************************************************
 *   Copyright (C) 2005, 2006 by Hannes Hauswedell                         *
 *   hannes.hauswedell@gmail.com                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "kports.h"
#include "pref.h"
#include "bsdport.h"

#include <qdragobject.h>
#include <qpainter.h>
#include <qpaintdevicemetrics.h>

#include <kglobal.h>
#include <klocale.h>
#include <kiconloader.h>
#include <kdeversion.h>
#include <kmenubar.h>
#include <kstatusbar.h>
#include <kkeydialog.h>
#include <kaccel.h>
#include <kio/netaccess.h>
#include <kfiledialog.h>
#include <kconfig.h>
#include <kurl.h>
#include <kurldrag.h>
#include <kurlrequesterdlg.h>

#include <kedittoolbar.h>

#include <kstdaccel.h>
#include <kaction.h>
#include <kstdaction.h>

KPorts::KPorts()
    : KMainWindow( 0, "KPorts" ),
      m_view(new KPortsView(this))
{

    
    // accept dnd
//    setAcceptDrops(true);

    // then, setup our actions
    setupActions();
    
    // tell the KMainWindow that this is indeed the main widget
    setCentralWidget(m_view);



    // and a status bar
   statusBar()->show();

    // apply the saved mainwindow settings, if any, and ask the mainwindow
    // to automatically save settings if changed: window size, toolbar
    // position, icon size, etc.
    setAutoSaveSettings();


}

KPorts::~KPorts()
{
}
/*
void KPorts::load(const KURL& url)
{
    QString target;
    // the below code is what you should normally do.  in this
    // example case, we want the url to our own.  you probably
    // want to use this code instead for your app

    #if 0
    // download the contents
    if (KIO::NetAccess::download(url, target))
    {
        // set our caption
        setCaption(url);

        // load in the file (target is always local)
        loadFile(target);

        // and remove the temp file
        KIO::NetAccess::removeTempFile(target);
    }
    #endif

    setCaption(url.prettyURL());
    m_view->openURL(url);
}
*/
void KPorts::setupActions()
{
//    KStdAction::open(this, SLOT(fileOpen()), actionCollection());
//    KStdAction::save(this, SLOT(fileSave()), actionCollection());
//    KStdAction::saveAs(this, SLOT(fileSaveAs()), actionCollection());

    m_toolbarAction = KStdAction::showToolbar(this, SLOT(optionsShowToolbar()), actionCollection());
    m_statusbarAction = KStdAction::showStatusbar(this, SLOT(optionsShowStatusbar()), actionCollection());

    KStdAction::keyBindings(this, SLOT(optionsConfigureKeys()), actionCollection());
//    KStdAction::configureToolbars(this, SLOT(optionsConfigureToolbars()), actionCollection());
    KStdAction::preferences(this, SLOT(optionsPreferences()), actionCollection());


	KIconLoader loader;
	QString string1(""),string2(""), string3("");

	
    
	    
	/// App Menu
	switch (QBsdPort::global->platform.pkgsystem)
	{
		case 2:	string1 = i18n("Reload Index (&PkgSrc");
	    		string2 = i18n("Reload FTP-Index (&Bin. Packages)");
	    		string3 = i18n("Reload PkgDb (&Inst. Packages)");
	    		break;
	    	default:
	    		string1 = i18n("Reload Index (&Portstree)");
	    		string2 = i18n("Reload FTP-Index (&Bin. Packages)");
			string3 = i18n("Reload PkgDb (&Inst. Packages)");
			break;
	}
	///reload submenu
	(void)new KAction(string1, "reload", 0, this, SLOT(optionsPreferences()), actionCollection(), "reload_avsrc");
	(void)new KAction(string2, "reload", 0, this, SLOT(optionsPreferences()), actionCollection(), "reload_avbin");
	(void)new KAction(string3, "reload", 0, this, SLOT(optionsPreferences()), actionCollection(), "reload_inst");
	
	KStdAction::quit(kapp, SLOT(quit()), actionCollection(), "quit");
	
	    
	///edit Menu
	(void)new KAction(i18n("Expand all Folders") , "viewmag+", 0, m_view, SLOT(ExpandAll()), actionCollection(), "expandall");
	(void)new KAction(i18n("Collapse all Folders"), "viewmag-", 0, m_view, SLOT(CollapseAll()), actionCollection(), "collapseall");
	    
	    
	    
	/// Updates Menu
	switch (QBsdPort::global->platform.pkgsystem) /// different terminolgy used
	{
		case 2:	string1 = i18n("Update &PkgSrc");
	    		string2 = i18n("Update &Vulnerability Db");
	    		break;
	    	default:
	    		string1 = i18n("Update &Portstree");
	    		string2 = i18n("Update &Vulnerability Db");
	    		break;
	}
	    
	(void)new KAction(string1, "2uparrow", 0, m_view, SLOT(updatePorts()), actionCollection(), "update_avsrc");
//	(void)new KAction(string1, 0, 0, m_view, SLOT(updatePorts()), actionCollection(), "update_avsrc");
	(void)new KAction(string2, "lock", 0, m_view, SLOT(updateVulnaDb()), actionCollection(), "update_vulnadb");

	    
	/// read file menu
	
	(void)new KAction(i18n("UPDATING") , "kwrite", 0, m_view, SLOT(showUpdRest()), actionCollection(), "show_upd_rest");
	(void)new KAction(i18n("MOVED") , "kwrite", 0, m_view, SLOT(showMoved()), actionCollection(), "show_moved");
	    
	    
    createGUI();
}
/*
void KPorts::saveProperties(KConfig *config)
{
    // the 'config' object points to the session managed
    // config file.  anything you write here will be available
    // later when this app is restored

    if (!m_view->currentURL().isEmpty()) {
#if KDE_IS_VERSION(3,1,3)
        config->writePathEntry("lastURL", m_view->currentURL());
#else
        config->writeEntry("lastURL", m_view->currentURL());
#endif
    }
}

void KPorts::readProperties(KConfig *config)
{
    // the 'config' object points to the session managed
    // config file.  this function is automatically called whenever
    // the app is being restored.  read in here whatever you wrote
    // in 'saveProperties'

    QString url = config->readPathEntry("lastURL");

    if (!url.isEmpty())
        m_view->openURL(KURL(url));
}

void KPorts::dragEnterEvent(QDragEnterEvent *event)
{
    // accept uri drops only
    event->accept(KURLDrag::canDecode(event));
}

void KPorts::dropEvent(QDropEvent *event)
{
    // this is a very simplistic implementation of a drop event.  we
    // will only accept a dropped URL.  the Qt dnd code can do *much*
    // much more, so please read the docs there
    KURL::List urls;

    // see if we can decode a URI.. if not, just ignore it
    if (KURLDrag::decode(event, urls) && !urls.isEmpty())
    {
        // okay, we have a URI.. process it
        const KURL &url = urls.first();

        // load in the file
        load(url);
    }
}


void KPorts::fileOpen()
{
    // this slot is called whenever the File->Open menu is selected,
    // the Open shortcut is pressed (usually CTRL+O) or the Open toolbar
    // button is clicked

    // this brings up the generic open dialog
    //KURL url = KURLRequesterDlg::getURL(QString::null, this, i18n("Open Location") );

    // standard filedialog
    KURL url = KFileDialog::getOpenURL(QString::null, QString::null, this, i18n("Open Location"));
    if (!url.isEmpty())
        m_view->openURL(url);
}

void KPorts::fileSave()
{
    // this slot is called whenever the File->Save menu is selected,
    // the Save shortcut is pressed (usually CTRL+S) or the Save toolbar
    // button is clicked

    // save the current file
}

void KPorts::fileSaveAs()
{
    // this slot is called whenever the File->Save As menu is selected,
    KURL file_url = KFileDialog::getSaveURL();
    if (!file_url.isEmpty() && file_url.isValid())
    {
        // save your info, here
    }
}
*/
void KPorts::optionsShowToolbar()
{
    // this is all very cut and paste code for showing/hiding the
    // toolbar
    if (m_toolbarAction->isChecked())
        toolBar()->show();
    else
        toolBar()->hide();
}

void KPorts::optionsShowStatusbar()
{
    // this is all very cut and paste code for showing/hiding the
    // statusbar
    if (m_statusbarAction->isChecked())
        statusBar()->show();
    else
        statusBar()->hide();
}

void KPorts::optionsConfigureKeys()
{
    KKeyDialog::configure(actionCollection());
}

void KPorts::optionsConfigureToolbars()
{
    //use the standard toolbar editor
#if defined(KDE_MAKE_VERSION)
# if KDE_VERSION >= KDE_MAKE_VERSION(3,1,0)
    saveMainWindowSettings(KGlobal::config(), autoSaveGroup());
# else
    saveMainWindowSettings(KGlobal::config());
# endif
#else
    saveMainWindowSettings(KGlobal::config());
#endif

//	saveMainWindowSettings(KGlobal::config(), autoSaveGroup());
}

void KPorts::newToolbarConfig()
{
    // this slot is called when user clicks "Ok" or "Apply" in the toolbar editor.
    // recreate our GUI, and re-apply the settings (e.g. "text under icons", etc.)
    createGUI();

#if defined(KDE_MAKE_VERSION)
# if KDE_VERSION >= KDE_MAKE_VERSION(3,1,0)
    applyMainWindowSettings(KGlobal::config(), autoSaveGroup());
# else
    applyMainWindowSettings(KGlobal::config());
# endif
#else
    applyMainWindowSettings(KGlobal::config());
#endif
}

void KPorts::optionsPreferences()
{
	const QString 	tmp1 = QBsdPort::global->portsDir;
	const QString 	tmp2 = QBsdPort::global->pkgSite;
	const QString	tmp3 = QBsdPort::global->pkgDbDir;
	const QString	tmp4 = QBsdPort::global->portsDbDir;
	const QString	tmp5 = QBsdPort::global->indexPath;
	
	const bool 	tmp6 = QBsdPort::global->portaudit;
	const bool 	tmp7 = QBsdPort::global->portsnatch;
///TODO need to rework this
	KPortsPreferences dlg;
	if (dlg.exec())
	{
		if (tmp1 != QBsdPort::global->portsDir)
		{
			 QBsdPort::global->T_readUpdFile();
			
		}
			
		if (tmp5 != QBsdPort::global->indexPath)
		{
//			changeStatusbar("re-reading INDEX file");
			
			KMessageBox::information(this, i18n("KPorts needs to restart for the changes to take affect."
							"\nIt will do so now."),
							QString(), "dontWarnReloadIndex");
			this->hide();
			
			KRun::runCommand("kports");
			
			kapp->exit();
			
		} 
		
		if (tmp2 != QBsdPort::global->pkgSite)
		{
			 QBsdPort::global->T_findAllAvailableBin();
			
		}
			
		if ( (tmp6 == false) && (QBsdPort::global->portaudit == true) )
		{
			QBsdPort::global->T_findVulnas();
		}
			
	}
}

void KPorts::changeStatusbar(const QString& text)
{
    // display the text on the statusbar
    statusBar()->message(text);
}

void KPorts::changeCaption(const QString& text)
{
    // display the text on the caption
    setCaption(text);
}
#include "kports.moc"
