/***************************************************************************
 *   Copyright (C) 2005 by Hannes Hauswedell                               *
 *   soul.rebel@web.de                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef KPORTSPOPUPS_H
#define KPORTSPOPUPS_H

#include <qvariant.h>
#include <qdialog.h>
#include <qbuttongroup.h>
#include <qpushbutton.h>
#include <qsplitter.h>
#include <qlabel.h>
#include <qtextedit.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QButtonGroup;
class QPushButton;
class QSplitter;
class QLabel;
class QTextEdit;
class QCheckBox;

/// this is the dialog that is shown when warning is opened in the install overview
class PortWarningDlg : public QDialog
{
    Q_OBJECT

public:
    PortWarningDlg( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~PortWarningDlg() {}

    QButtonGroup* secGroup;
    QButtonGroup* flagGroup;
    QCheckBox* cBroken;
    QCheckBox* cIgnore;
    QCheckBox* cForbidden;
    QCheckBox* cRestricted;
    QCheckBox* cDeprecated;
    QButtonGroup* updGroup;
    QTextEdit* eUpdating;
    QButtonGroup* buttonGroup;
    QPushButton* okButton;

protected:
    QGridLayout* Form1Layout;
    QGridLayout* secGroupLayout;
    QGridLayout* flagGroupLayout;
    QGridLayout* updGroupLayout;
    QGridLayout* buttonGroupLayout;
    QSpacerItem* spacer1;
    QSpacerItem* spacer2;


};
/// this is the dialog that is shown when a options are to be edited in the install overview
class PortOptionsDlg : public QDialog
{
Q_OBJECT

public:
	PortOptionsDlg( QWidget* parent = 0, const char* name = 0 );
	~PortOptionsDlg() {}

	QButtonGroup* optionsGroup; 
	QButtonGroup* buttonGroup;
	QPushButton* okButton;

protected:
	QGridLayout* optionsGroupLayout;
	QGridLayout* buttonGroupLayout;
	QGridLayout* Form1Layout;    
	QSpacerItem* spacer1;
   	QSpacerItem* spacer2;
	
	

};
#endif // KPORTSPOPUPS_H
