/***************************************************************************
 *   Copyright (C) 2005, 2006 by Hannes Hauswedell                         *
 *   hannes.hauswedell@gmail.com                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kportsview.h"


QBsdPortGlobal* QBsdPort::global;
bool	KPortsView::g_bHideMainOnInstall= false;
QString	KPortsView::g_sPrefix		= "";


KPortsPrefConfig *KPortsView::Settings;
KPortsView	*KPortsView::mainWnd;



KPortsView::KPortsView(QWidget *parent, const char *name)
 : KPortsViewBase(parent, name)
{
	m_currentPort  = 0; /// need to initialize this

	loadConfig();
	
/*	/// (de)activate some action
	app->actionCollection()->action("reload_avsrc")->setEnabled(false);
	app->actionCollection()->action("reload_inst")->setEnabled(false);
	if (QBsdPort::global->portaudit)
	{
		app->actionCollection()->action("update_vulnadb")->setEnabled(false);
		app->actionCollection()->action("update_vulnadb")->setToolTip(i18n("You need to activate use of Portaudit in the Options."));
	}*/
	

			
	connect(QBsdPort::global, SIGNAL(indexFileNotFound()), this, SLOT(indexFileNotFound()));
	connect(QBsdPort::global, SIGNAL(vulnaDbOutdated()), this, SLOT(vulnaDbOutdated()));
	connect(QBsdPort::global, SIGNAL(vulnaDbUpdateSuccessful()), this, SLOT(vulnaDbUpdatedSuccessfully()));
	connect(QBsdPort::global, SIGNAL(vulnaDbUpdateUnsuccessful(QString)), this, SLOT(vulnaDbUpdatedUnsuccessfully(QString)));
	connect(QBsdPort::global, SIGNAL(findAllAvBinProgress(int)), this, SLOT(avBinProgress(int)));
	

	connect(QBsdPort::global, SIGNAL(searchFinished(QPtrList <QBsdPort>)), this, SLOT(searchFinished(QPtrList <QBsdPort>)));


	connect(QBsdPort::global, SIGNAL(T_findAllAvailableSrcFinished()), this, SLOT(allAvSrcFound()));
	connect(QBsdPort::global, SIGNAL(T_findAllInstalledFinished()), this, SLOT(allInstFound()));
//	connect(QBsdPort::global, SIGNAL(T_findAllAvailableBinFinished()), this, SLOT(allAvBinFound()));
	connect(QBsdPort::global, SIGNAL(T_readUpdFileFinished()), this, SLOT(updFileRead()));
	connect(QBsdPort::global, SIGNAL(T_findVulnasFinished()), this, SLOT(vulnasFound()));


	mainWnd=this;	

//	eWWW->setPalette(eName->palette());
	eWWW->setSelectedColor((QString)"blue");
	eWWW->setUnderline(false);
	eWWW->setFloat(true);
//	eMaint->setPalette(eName->palette());
	eMaint->setSelectedColor((QString)"blue");
	eMaint->setUnderline(false);
	eMaint->setFloat(true);
		
	cExact->hide();

//	connect(eMaint, SIGNAL(leftURL()), this, SLOT(mouseLeftURL()));
//	connect(eWWW, SIGNAL(leftURL()), this, SLOT(mouseLeftURL()));
	

	TPortInfo->setEnabled(false);


	
/*	ListView->setResizeMode(QListView::AllColumns);
	ListViewInst->setResizeMode(QListView::AllColumns);
	ListViewSearch->setResizeMode(QListView::AllColumns);
	lDeps->setResizeMode(QListView::AllColumns);
	lReqs->setResizeMode(QListView::AllColumns);*/



	app=(KPorts*)parent;

	QPixmap clear 	= IconLoader.loadIcon((QString)"locationbar_erase", KIcon::NoGroup);
	QPixmap expand 	= IconLoader.loadIcon((QString)"edit_add", KIcon::NoGroup);
	QPixmap collapse = IconLoader.loadIcon((QString)"edit_remove", KIcon::NoGroup);
	QPixmap reload 	= IconLoader.loadIcon((QString)"edit_remove", KIcon::NoGroup);
//	QPixmap warning = IconLoader.loadIcon((QString)"messagebox_warning", KIcon::Small,24);
//	QPixmap ok	= IconLoader.loadIcon((QString)"ok", KIcon::Small, 28);

	/// set some icons

	bClearAll->setPixmap(clear);
	bClearInst->setPixmap(clear);
	bClearSearch->setPixmap(clear);
	bExportPkg->setIconSet(IconLoader.loadIcon((QString)"filesave", KIcon::NoGroup));
	bUninstall->setIconSet(IconLoader.loadIcon((QString)"trashcan_empty", KIcon::Small));
	bSearchDescr->setIconSet(IconLoader.loadIcon((QString)"find", KIcon::Small));

	eIcon->setPixmap(IconLoader.loadIcon((QString)"package", KIcon::NoGroup, 80));

	MainTab->setTabIconSet(MainTab->page(2), IconLoader.loadIcon((QString)"kfind", KIcon::Small));
	MainTab->setTabIconSet(MainTab->page(0), IconLoader.loadIcon((QString)"player_playlist", KIcon::Small));
	MainTab->setTabIconSet(MainTab->page(1), IconLoader.loadIcon((QString)"hdd_unmount", KIcon::Small));
	
	installViewFilterBox->insertItem(IconLoader.loadIcon((QString)"hdd_unmount", KIcon::Small), i18n("all"));
	installViewFilterBox->insertItem(IconLoader.loadIcon((QString)"up", KIcon::Small), i18n("upgradeable"));
	
	
	cbSearchType->insertItem(IconLoader.loadIcon((QString)"hdd_unmount", KIcon::Small), i18n("Description"), 4);
	cbSearchType->insertItem(IconLoader.loadIcon((QString)"hdd_unmount", KIcon::Small), i18n("Files"), 5);

	secGroup->setIcon(IconLoader.loadIcon((QString)"message_warning", KIcon::Small));
	flagGroup->setIcon(IconLoader.loadIcon((QString)"message_critical", KIcon::Small));
		
	secGroup->layout()->setAutoAdd(true);
	optionsGroup->layout()->setAutoAdd(true);


	/// set some resize beheaviour
	ListView->header()->setStretchEnabled(true, 0);
	ListViewInst->header()->setStretchEnabled(true, 0);
	ListViewSearch->header()->setStretchEnabled(true, 0);

	isStarting = true;
	
	populateView();
	
}

void KPortsView::loadConfig()
{

	Settings = new KPortsPrefConfig(KSharedConfig::openConfig("kportsrc"));
	Settings->readConfig();
	
	QDir kportsdir(QDir::homeDirPath() + "/.kports");
	if (!kportsdir.exists())
		kportsdir.mkdir(QDir::homeDirPath() + "/.kports");

}

void KPortsView::mouseLeftURL()
{
	eWWW->setPalette(eName->palette());
	eMaint->setPalette(eName->palette());
}

KPortsView::~KPortsView()
{
	Settings->writeConfig();	

/*	for (int i=0; i<THREADNO; i++)
	{
		if (freshen[i].isActive())
			if (freshen[i].m_iAction==15)
				freshen[i].halt();
	}

	for (int i=0; i<THREADNO; i++)
	{
		if (!freshen[i].finished())
			freshen[i].wait(10);
	}

	for (int i=0; i<THREADNO; i++)
	{
		if (!freshen[i].finished())
			freshen[i].terminate();
	}
	

	delete [] freshen;*/
}



void KPortsView::populateView()
{
	clearTab();

	MainTab->page(0)->setEnabled(false);
	MainTab->page(1)->setEnabled(false);
	MainTab->page(2)->setEnabled(false);
	

	if (QBsdPort::global->portaudit)
	{
		secGroup->show();
//		QToolTip::add(versionTable, i18n("If a version is marked by an exclamation mark, it might be insecure.\nDouble-click it to view more details."));
//		if (installViewFilterBox->count()==2)
//			installViewFilterBox->insertItem(IconLoader.loadIcon((QString)"unlock", KIcon::Small), i18n("vulnerable"));
	} else
	{
		secGroup->hide();
//		QToolTip::remove(versionTable);
		if (installViewFilterBox->count()==3)
			installViewFilterBox->removeItem(2);
	}


	/// when application is starting the gui isnt visible and running these calls unthreaded is faster
	if (isStarting)
	{
//		if (QBsdPort::global->activeProcs.contains("findAllAvBinProc"))
		{
			QBsdPort::global->stopProc("findAllAvBinProc");
//			hadToInteruptFindAvBinProc = 1;
		}
			
		QBsdPort::global->array.clear(); /// we use "is starting" also in other situation, where the contents has to be cleared
		
		QBsdPort::global->findAllAvailableSrc();
		allAvSrcFound();
		QBsdPort::global->findAllInstalled();
		allInstFound();
		isStarting = false;

	} else /// when executed because of options change, calls need to be threaded to not lockup gui
	{
		QBsdPort::global->T_findAllAvailableSrc();
		QBsdPort::global->T_findAllInstalled();
	}
	/// these are always started threaded because they dont have to be available imediately
	QBsdPort::global->T_findAllAvailableBin();
	QBsdPort::global->T_readUpdFile();
	if (QBsdPort::global->portaudit)
		QBsdPort::global->T_findVulnas();		



	
	if (QBsdPort::global->firstRun)
	{
		KMessageBox::information(this, i18n("You are using this version of KPorts for the first time. Please go to "
						"\"Settings->Configure KPorts\" and adjust the defaults to your Environment.\n"
						"Also make sure that you have the following ports installed:\n"
						"sysutils/portupgrade (required)\nnet/cvsup-without-gui (required)\n"
						"security/portaudit (recommended)\n"
						"I hope KPorts will be useful to you, feedback is alway welcome!\n"
						" - http://kports.sf.net"));
		QBsdPort::global->firstRun = false;
	}

}

void KPortsView::allAvSrcFound()
{
	if (isStarting) /// all inst found will take care of stuff in this case (so that stale ports are added to all)
		return;
	
	eSearch->setListView(0);
	ListView->clear();
	ListViewInst->clear();

	for (QBsdPort *port = QBsdPort::global->array.first(); port; port = QBsdPort::global->array.next())
		insertPortInView(ListView, port);

	MainTab->page(0)->setEnabled(true);
	MainTab->page(1)->setEnabled(true);
	MainTab->page(2)->setEnabled(true);	
	MainTab->setTabLabel(MainTab->page(0), i18n("All ") + "[" + QString::number(QBsdPort::global->array.count()) + "]" );
			
	eSearch->setListView(ListView);
	eSearch->updateSearch();
		
	
}

void KPortsView::allInstFound()
{
	if (isStarting)
	{
		QString b1 = eSearch->text();
		QString b2 = eSearchInst->text();
		eSearch->clear();
		eSearchInst->clear();
		eSearch->setListView(0);
		eSearchInst->setListView(0);
		
		ListView->clear();
		ListViewInst->clear();
		
		
		
		uint all 	= QBsdPort::global->array.count(),
		     installed	= 0;
//		QBsdPort::global->getMutex.lock();/// dirty solution du prevent acess messup when findAllAvBin is running in seperate thread
		for (QBsdPort *port = QBsdPort::global->array.first(); port; port = QBsdPort::global->array.next())
		{
			if (port->installed())
			{
				insertPortInView(ListViewInst, port);
				++installed;
			}
			insertPortInView(ListView, port);
		}
//		QBsdPort::global->getMutex.unlock();
		
		MainTab->page(0)->setEnabled(true);
		MainTab->setTabLabel(MainTab->page(0), i18n("All ") + "[" + QString::number(all) + "]" );
		MainTab->page(1)->setEnabled(true);
		MainTab->setTabLabel(MainTab->page(1), i18n("Installed ") + "[" + QString::number(installed) + "]" );
		MainTab->page(2)->setEnabled(true);
		eSearch->setListView(ListView);
		eSearchInst->setListView(ListViewInst);
		eSearch->setText(b1);
		eSearchInst->setText(b2);
		eSearchInst->updateSearch();
		eSearch->updateSearch();
		
	} else
	{
		QString b2 = eSearchInst->text();
		eSearchInst->clear();
		eSearchInst->setListView(0);
		ListViewInst->clear();
	
		uint all 	= QBsdPort::global->array.count(),
		     installed	= 0;
		for (QBsdPort *port = QBsdPort::global->array.first(); port; port = QBsdPort::global->array.next())
		{
			if (port->installed())
			{
				insertPortInView(ListViewInst, port);
				++installed;
			}
			
			if (!port->avSource())	/// insert stale ports in the first listview
				insertPortInView(ListView, port);
		}
		
		MainTab->page(1)->setEnabled(true);
		MainTab->setTabLabel(MainTab->page(0), i18n("All ") + "[" + QString::number(all) + "]" );
		MainTab->page(2)->setEnabled(true);
		MainTab->setTabLabel(MainTab->page(1), i18n("Installed ") + "[" + QString::number(installed) + "]" );
				
		eSearchInst->setText(b2);
		eSearchInst->setListView(ListViewInst);
		eSearchInst->updateSearch();
		
	}
}


void KPortsView::allAvBinFound()
{
//	app->changeStatusbar("all bins found");
}

				
void KPortsView::avBinProgress(int progress)
{
	switch(progress)
	 {
		case 1: app->changeStatusbar(i18n("Updating Ftp-Index")); break;
		case 2: app->changeStatusbar(i18n("Reading Ftp-Index")); break;
		case 3: app->changeStatusbar("");
			KMessageBox::detailedError(this, i18n("An Error ocurred trying to update/read the List of available" 
							"binary Packages. Check the Packagesite Entry in you options" 
							"and your Internet connection."), i18n("A Log was saved at ") +
							QDir::homeDirPath() + "/.kports/fetchFTPINDEX.log", i18n("Ftp-Index"));
			break;
		case 4: app->changeStatusbar(""); break;
	}
				
				
}
void KPortsView::updFileRead()
{
}

void KPortsView::vulnasFound()
{
//	app->changeStatusbar("all vulnas found");
	if (installViewFilterBox->count()==2)
		installViewFilterBox->insertItem(IconLoader.loadIcon((QString)"unlock", KIcon::Small), i18n("insecure"));

}


void KPortsView::searchFinished(QPtrList <QBsdPort> result)
{

	ListViewSearch->clear();

	for (QBsdPort *port = result.first(); port; port = result.next())
		insertPortInView(ListViewSearch, port);
		
	MainTab->setTabLabel(MainTab->page(2), i18n("Search ") + "[" + QString::number(result.count()) + "]" );

	bClearSearch->setEnabled(true);
	bSearchDescr->setEnabled(true);
	eSearchDescr->setEnabled(true);
	cbSearchType->setEnabled(true);
		
	QApplication::restoreOverrideCursor();
}

void KPortsView::NewItemSelected()
{
	currentItem = (KListViewItem*)currentListView()->selectedItem();
	//fix some stupid bug, causing segfault when kports becomes active
//	QPixmap pic1 = currentItem->pixmap(0);
//	QPixmap pic2 = IconLoader.loadIcon((QString)"info", KIcon::Small);
	if ( (currentItem==NULL ) )//|| (pic1 == pic2) )
		return;
	else
		updateTab();
}

void KPortsView::insertPortInView(QListView *view, QBsdPort *Port)
{
	QString catname = Port->origin().section('/',0,0);
	QString pname	= Port->origin().section('/',1,1);
	bool	over	= false;

	QListViewItem *temp	= view->firstChild();
	QListViewItem *portItem;

	while ( (temp!=0) && (!over) ) //find cat item to insert into
	{
		if ( (temp->parent()==0) && (temp->text(0)==catname) )
		{
			portItem = new QListViewItem(temp);
			portItem->setText(0,pname);
			portItem->setPixmap(0,IconLoader.loadIcon((QString)"package", KIcon::Small));
			if (Port->installed())
				portItem->setText(1, Port->installed()->version());
				
			if (Port->avSource())
				portItem->setText(2, Port->avSource()->version());
			over=true;
		}
		temp = temp->itemBelow();
	}
	
	if (!over) //if none was found make new one and insert into
	{
		temp = new QListViewItem(view);
		temp->setPixmap(0,IconLoader.loadIcon((QString)"folder", KIcon::Small));
		temp->setText(0,catname);

		portItem = new QListViewItem(temp);
		portItem->setPixmap(0,IconLoader.loadIcon((QString)"package", KIcon::Small));
		portItem->setText(0,pname);
			
		if (Port->installed())
			portItem->setText(1, Port->installed()->version());
				
		if (Port->avSource())
			portItem->setText(2, Port->avSource()->version());
		
	}


}
void KPortsView::pathToListViewItems(QListView *view, QString path, bool leadingSlash, bool allowDuplicate)
{

	QStringList parts = QStringList::split('/', path, leadingSlash);


	QListViewItem	*currentFolder = (QListViewItem*)view;
	QListViewItem	*temp;

	bool over;

	for ( int i=0; i < parts.count(); i++ )  
	{
//		std::cout << *it << endl;
		if (i == 0)
			temp = view->firstChild();
		else
			temp = currentFolder->firstChild();
		over = false;

		if ( (!allowDuplicate) || (i < parts.count()-1) )
		{
			
			while ( (temp!=0) && (!over) )
			{
				if (temp->text(0)==parts[i]) //check if selected object has right name
					over = true;
				else
					temp = temp->nextSibling(); //if not bext item is seleceted 
			}
		}
//		else
//			std::cout << "gestoppt\n";

		if (!over)
		{
			if (i == 0)
				temp = new QListViewItem(view);
			else
				temp = new QListViewItem(currentFolder);
	
			if (i < parts.count()-1)
				temp->setPixmap(0,IconLoader.loadIcon((QString)"folder", KIcon::Small));
			else
				temp->setPixmap(0,IconLoader.loadIcon((QString)"tar", KIcon::Small));
			
			temp->setText(0,parts[i]);
			
			
		}	

		currentFolder = temp;	
	}

}

void KPortsView::clearTab()
{
	clearPortInfo();
	clearPkgInfo();
}

void KPortsView::clearPortInfo()
{
	/// clear the information that is PORT specific from (not which is package specific)
	eOrigin->setText("");

	bInst->setText("");
	bAvSrc->setText("");
	bAvBin->setText("");
	bInst->hide();
	bAvSrc->hide();
	bAvBin->hide();
//	eInst->setFrameStyle(QFrame::NoFrame);
//	eAvSrc->setFrameStyle(QFrame::NoFrame);
//	eAvBin->setFrameStyle(QFrame::NoFrame);
	eIcon->setPixmap(IconLoader.loadIcon((QString)"package", KIcon::NoGroup, 80));

					
					//	QToolTip::remove( versionTable->cellWidget(0,0));
//	QToolTip::remove( versionTable->cellWidget(0,1));
//	QToolTip::remove( versionTable->cellWidget(0,2));
	TPortInfo->setEnabled(false);

					
}

void KPortsView::clearPkgInfo()
{
	/// clear the information that is package specific
	eName->setText("");
	eMaint->setText("");
	eWWW->setText("");
	eComment->setText("");
	eCategories->setText("");
	eSize->setText("");
	lDeps->clear();
	lReqs->clear();
	lFiles->clear();
	tFiles->setText("");
	eDescr->clear();
	eMessage->setText("");
	ePkgURL->clear();
	ePrefix->setText("");
	ePkgURL->clear();
					
	if (lFiles->columns() > 1)
		lFiles->removeColumn(1);
		
					
	if (QBsdPort::global->portaudit)
	{				
		tNoSec->show();
		QObjectList *l = secGroup->queryList( "KURLLabel" );
		QObjectListIt it( *l ); // iterate over the buttons
		QObject *obj;
	
		while ( (obj = it.current()) != 0 ) 
		{
			// for each found object...
			++it;
			obj->disconnect(this);
			((QWidget*)obj)->hide();
			secGroup->layout()->removeChild(obj);
			secGroup->removeChild(obj);
			((QWidget*)obj)->deleteLater();
		}
		secGroup->layout()->activate();
	}
	
	tNoOptions->show();
	QObjectList *l = optionsGroup->queryList( "QCheckBox" );
	QObjectListIt it( *l ); // iterate over the buttons
	QObject *obj;

	while ( (obj = it.current()) != 0 ) 
	{
		// for each found object...
		++it;
		((QWidget*)obj)->hide();
		optionsGroup->layout()->removeChild(obj);
		optionsGroup->removeChild(obj);
		((QWidget*)obj)->deleteLater();
	}
	optionsGroup->layout()->activate();

					
	eUpdating->clear();
	
	///acutally are set by avsrc pkg but are shown for all
	flagGroup->hide();
	cIgnore->hide();
	cBroken->hide();
	cRestricted->hide();
	cForbidden->hide();
	cDeprecated->hide();	
	eIgnore->hide();
	eBroken->hide();
	eRestricted->hide();
	eForbidden->hide();
	eDeprecated->hide();	
	
	updGroup->setEnabled(false);
//	tNoUpd->setText(i18n("Does not apply (Port not installed or installed version not selected)."));
	eUpdating->hide();
	tNoUpd->show();
					
/*	if ( (UPDATINGTab==0) )
	{
		UPDATINGTab = extendedInfo->page(0);
		extendedInfo->removePage(UPDATINGTab);
	} */

}


void KPortsView::setCurrentPort(QBsdPort* newValue)
{
	if (currentPort())
	{
		currentPort()->disconnect(this);	///remove all connections from port to frontend
		/// and children
		if (currentPort()->installed())
			currentPort()->installed()->disconnect(this);
		if (currentPort()->avSource())
			currentPort()->avSource()->disconnect(this);
		if (currentPort()->avBinary())
			currentPort()->avBinary()->disconnect(this);
	}
	m_currentPort = newValue;
}

void KPortsView::updateTab()
{
	QApplication::setOverrideCursor(KCursor::waitCursor());
	
	clearTab();	/// make sure nothing is visible

	currentItem = (KListViewItem*)currentListView()->selectedItem();

	if (currentItem==0)
	{
		setCurrentPort(0);
		clearTab();
		QApplication::restoreOverrideCursor();
		return;
	}

	KListViewItem *parent = (KListViewItem*)currentItem->parent();

	if (currentItem->parent()==0) //category was selected
	{
//		m_bCurrentIsCat = true;
		setCurrentPort(0);
		clearTab();
		QApplication::restoreOverrideCursor();
		return;
	}
	else
	{
//		m_bCurrentIsCat = false;

		setCurrentPort(QBsdPort::global->portWithOrigin(parent->text(0)+"/"+currentItem->text(0)));
	}

	
	/// set origin field (independant from selected PKG)
	eOrigin->setText(currentPort()->origin());

	/// set icon
	QString iconstr("");
	QString Name("");
	if (currentPort()->avSource())
		Name = currentPort()->avSource()->name();
	else
		Name = currentPort()->installed()->name();
	
	QPixmap icon = IconLoader.loadIcon(Name, KIcon::NoGroup, 80,KIcon::DefaultState, &iconstr, true);
	if (iconstr == "")
	{
		if (Name.contains("i18n",false))
			eIcon->setPixmap(IconLoader.loadIcon((QString)"locale", KIcon::NoGroup, 80));
		else if (Name.contains("kde",false))
			eIcon->setPixmap(IconLoader.loadIcon((QString)"kmenu", KIcon::NoGroup, 80));
		else
			eIcon->setPixmap(IconLoader.loadIcon((QString)"package", KIcon::NoGroup, 80));
	} else
		eIcon->setPixmap(icon);

	/// versions
	if (currentPort()->installed())
	{
		bInst->show();
		bInst->setText(currentPort()->installed()->version());
	}
	if (currentPort()->avSource())
	{
		bAvSrc->show();
		bAvSrc->setText(currentPort()->avSource()->version());
	}
	if (currentPort()->avBinary())
	{
		bAvBin->show();
		bAvBin->setText(currentPort()->avBinary()->version());
	}



	


//	versionTable->adjustColumn(0);
//	versionTable->adjustColumn(1);
//	versionTable->adjustColumn(2);
//	versionTable->horizontalHeader()->adjustHeaderSize();


	/// get the right icon on install button
	QString tmp1, tmp2;
	QString version1, version2, version3;
	if (currentPort()->installed())
		version1 = currentPort()->installed()->version();
	else
		version1 = "";
	if (currentPort()->avSource())
		version2 = currentPort()->avSource()->version();
	else
		version2 = "";
	if (currentPort()->avBinary())
		version3 = currentPort()->avBinary()->version();
	else
		version3 = "";
	bUninstall->setEnabled(true);
	if (version1 == "" ) 
		bUninstall->setEnabled(false);

	tmp1 = "";
	
	bInstall->setEnabled(false);

	if (version2 == "")
		tmp1 = "";
	else if (version1 == "")
	{
		tmp1 = i18n("Inst&all/");		//necessary so it wont show upgrade
		bInstall->setIconSet(IconLoader.loadIcon((QString)"next", KIcon::Small));
	}
	else if (version1 == version2 )
	{
		tmp1 = i18n("Reinst&all/");
		bInstall->setIconSet(IconLoader.loadIcon((QString)"next", KIcon::Small));
	}
	else if (version1 < version2 )
	{
		tmp1 = i18n("Upgr&ade/");
		bInstall->setIconSet(IconLoader.loadIcon((QString)"up", KIcon::Small));
	}
	else if (version1 > version2 )
	{
		tmp1 = i18n("Downgr&ade/"); 
		bInstall->setIconSet(IconLoader.loadIcon((QString)"down", KIcon::Small));
	}
	if (version3 == "")
		tmp1.remove(tmp1.length()-1,1);
	else if (version1 == "")
	{
		if (tmp1!=i18n("Inst&all/"))
			tmp1 += i18n("Install");
		else
			tmp1.remove(tmp1.length()-1,1);
		bInstall->setIconSet(IconLoader.loadIcon((QString)"next", KIcon::Small));
	}
	else if (version1 == version3 )
	{
		if (tmp1!=i18n("Reinst&all/"))
			tmp1 += i18n("Reinstall");
		else
			tmp1.remove(tmp1.length()-1,1);
		bInstall->setIconSet(IconLoader.loadIcon((QString)"reload", KIcon::Small));
	}
	else if (version1 < version3 )
	{
		if (tmp1!=i18n("Upgr&ade/"))
			tmp1 += i18n("Upgrade");
		else
			tmp1.remove(tmp1.length()-1,1);
		bInstall->setIconSet(IconLoader.loadIcon((QString)"up", KIcon::Small));
	}
	else if (version1 > version3 )
	{
		if (tmp1!=i18n("Downgr&ade/"))
			tmp1 += i18n("Downgrade");
		else
			tmp1.remove(tmp1.length()-1,1);
		bInstall->setIconSet(IconLoader.loadIcon((QString)"down", KIcon::Small));
	}
	
	bInstall->setText(tmp1);
	if ( (bInstall->text()!="") && (bInstall->text()!=i18n("&Please Wait")) )
		bInstall->setEnabled(true);

				
	/// rest of info depends on and is therfor set by package
	/// if an installed pakcage exists we will default to its info
	TPortInfo->setEnabled(true);


	if (version1!="")
	{
		instVersionSelected();
		
	} else /// else to the avsource package
	{
		avSrcVersionSelected();
	}
	
	QApplication::restoreOverrideCursor();
}

void KPortsView::showInfo() 
{
	clearPkgInfo();

	/// we will display all the information
	switch(currentPkg())
	{
		case 0:{ /** installed package **/
			QBsdPortInstPkg *Pkg = currentPort()->installed();
//			if (!Pkg)
//				return; /// need to return because of some stupid bug this gets called at wrong times

			/// name
			eName->setText(Pkg->name()); 
			/// categories
			if ( (QBsdPort::global->combinePkgInfo) && (currentPort()->avSource()) )	
				eCategories->setText(currentPort()->avSource()->categories());
			else
				eCategories->setText(currentPort()->origin().section('/',1,1));
			/// maint
			if ( (QBsdPort::global->combinePkgInfo) && (currentPort()->avSource()) )
				eMaint->setText(currentPort()->avSource()->maint());
			else
				eMaint->setText("");
			/// url
			eWWW->setText(Pkg->www());
			eWWW->setURL(Pkg->www());
			/// comment
			eComment->setText(Pkg->comment());
			/// updating warning		
/*			if ( (Pkg->updWarning()=="") && (UPDATINGTab==0) )
			{
				UPDATINGTab = extendedInfo->page(0);
				extendedInfo->removePage(UPDATINGTab);
			} else if ( (Pkg->updWarning()!="") && (UPDATINGTab!=0) )
			{
				extendedInfo->insertTab(UPDATINGTab, i18n("Warning!"), 0);
				extendedInfo->setCurrentPage(0);
				UPDATINGTab = 0;
			}*/
			updGroup->setEnabled(true);
			if (Pkg->updWarning()=="")
				tNoUpd->setText(i18n("No Warnings."));
			else
			{
				tNoUpd->hide();
				eUpdating->show();	
				eUpdating->setText(Pkg->updWarning());
			}
			/// description
			eDescr->setText(Pkg->descr());
			/// files
			lFiles->clear();
			if (Pkg->files()!="")
			{
				QStringList tmp = QStringList::split('|', Pkg->files());
				QString tmp2;
				QListViewItem* tmpitem;
				for ( QStringList::Iterator it = tmp.begin(); it != tmp.end(); it++ )
				{
					tmp2 = *it;
	
					tmpitem = new QListViewItem(lFiles);
					tmpitem->setText(0, tmp2);
					tmpitem->setPixmap(0,IconLoader.loadIcon((QString)"unknown", KIcon::Small));
					
					
				}
				lFiles->adjustColumn(0);
			}
			/// false files
			if (Pkg->falseFiles() == "no_init") /// may not be retrieved yet 
			{
				connect(currentPort()->installed(), SIGNAL(T_findFalseFilesFinished()), SLOT(refreshInstFalseFiles()));
				Pkg->T_findFalseFiles();
			} else		
				refreshInstFalseFiles(); /// the slot does it
			tFiles->setText(i18n("Installed Files:"));
			lFiles->adjustColumn(0);
			/// size
			tSize->show(); /// make sure they are not hidden
			eSize->show();
			if (Pkg->size() == 0)
			{
				connect(currentPort()->installed(), SIGNAL(T_findSizeFinished()), SLOT(refreshInstSize()));
				Pkg->T_findSize();
			} else
				refreshInstSize();
			/// dependencies and requirements
			lReqs->clear();
			if (Pkg->reqs()!="")
			{
				QStringList tmp = QStringList::split(' ', Pkg->reqs());
				QString tmp2;
				QListViewItem* tmpitem;
				for ( QStringList::Iterator it = tmp.begin(); it != tmp.end(); it++ )
				{
					tmp2 = *it;
	
					tmpitem = new QListViewItem(lReqs);
					tmpitem->setText(0, tmp2);
					tmpitem->setPixmap(0,IconLoader.loadIcon((QString)"package", KIcon::Small));			
				}
			}
			tDeps->show();
			lDeps->show();
			lDeps->clear();
			if (Pkg->deps()!="")
			{
				QStringList tmp = QStringList::split(' ', Pkg->deps());
				QString tmp2;
				QListViewItem* tmpitem;
				for ( QStringList::Iterator it = tmp.begin(); it != tmp.end(); it++ )
				{
					tmp2 = *it;
	
					tmpitem = new QListViewItem(lDeps);
					tmpitem->setText(0, tmp2);
					tmpitem->setPixmap(0,IconLoader.loadIcon((QString)"package", KIcon::Small));			
				}
			}
			/// prefix
			tPrefix->setText(i18n("Installation Prefix:"));
			ePrefix->setText(Pkg->prefix());
			
			/// message
			if (Pkg->message()!="")
				eMessage->setText(Pkg->message());
			else
				eMessage->setText("Package has no message.");

			/// package create url default
			ePkgURL->setURL(QDir::homeDirPath()+"/"+Pkg->name()+"-"+Pkg->version()+".tbz");

	
			wsAdvanced->raiseWidget(0);

			/// security warnings
			if (QBsdPort::global->portaudit)
			{
				if (Pkg->vulna()=="no_init")
				{
					connect(currentPort()->installed(), SIGNAL(T_findVulnaFinished()), this, SLOT(refreshVulna()));
					currentPort()->installed()->T_findVulna();
				} else		
					refreshVulna(); /// the slot does it
			}
				
			connect(currentPort()->installed(), SIGNAL(exportPkgSuccessful()), this, SLOT(pkgExportedSuccessfully()));
			connect(currentPort()->installed(), SIGNAL(exportPkgUnsuccessful(QString)), this, SLOT(pkgExportedUnsuccessfully(QString)));
			}break;

		case 1:{ /** avsource package **/
			QBsdPortAvSrcPkg *Pkg = currentPort()->avSource();
//			if (!Pkg)
//				return; /// need to return because of some stupid bug this gets called at wrong times

			/// name
			eName->setText(Pkg->name()); 
			/// categories	
			eCategories->setText(Pkg->categories());
			/// maint
			eMaint->setText(Pkg->maint());
			/// url
			eWWW->setText(Pkg->www());
			eWWW->setURL(Pkg->www());
			/// comment
			eComment->setText(Pkg->comment());
			/// updating warning		
/*			if ( (UPDATINGTab==0) )
			{
				UPDATINGTab = extendedInfo->page(0);
				extendedInfo->removePage(UPDATINGTab);
			} 
*/			/// description
			if (Pkg->descr() == "no_init") /// may not be retrieved yet
			{
				connect(currentPort()->avSource(), SIGNAL(T_findDescrFinished()), this, SLOT(refreshSrcDescr()));
				Pkg->T_findDescr();
				
			} else
				refreshSrcDescr();
			/// files
			if (Pkg->files()== "no_init") /// may not be retrieved yet
			{
				connect(currentPort()->avSource(), SIGNAL(T_findFilesFinished()), this, SLOT(refreshSrcFiles()));
				Pkg->T_findFiles();
				
			} else
				refreshSrcFiles(); /// the slot does it
			tFiles->setText(i18n("To-Be Installed Files:"));
			/// size, have to make sure they're not there
			tSize->hide(); 
			eSize->hide();
			/// dependencies and requirements
			lReqs->clear();
			if (Pkg->reqs()!="")
			{
				QStringList tmp = QStringList::split(' ', Pkg->reqs());
				QString tmp2;
				QListViewItem* tmpitem;
				for ( QStringList::Iterator it = tmp.begin(); it != tmp.end(); it++ )
				{
					tmp2 = *it;
	
					tmpitem = new QListViewItem(lReqs);
					tmpitem->setText(0, tmp2);
					tmpitem->setPixmap(0,IconLoader.loadIcon((QString)"package", KIcon::Small));			
				}
			}
			tDeps->hide();/// make sure these arent there (only installed ports have deps!)
			lDeps->hide();

			/// prefix
			tPrefix->setText(i18n("Default Installation Prefix:"));
			ePrefix->setText(Pkg->prefix());
					
			/// security warnings
			if (QBsdPort::global->portaudit)
			{
				if (Pkg->vulna()=="no_init")
				{
					connect(currentPort()->avSource(), SIGNAL(T_findVulnaFinished()), this, SLOT(refreshVulna()));
					Pkg->T_findVulna();
				} else		
					refreshVulna(); /// the slot does it
			}

			/// flags
			if (Pkg->ignore()=="no_init")
			{
				connect(currentPort()->avSource(), SIGNAL(T_findFlagsFinished()), this, SLOT(refreshFlags()));
				Pkg->T_findFlags();
			} else		
				refreshFlags(); /// the slot does it
				
				
			/// options
			if (Pkg->options()=="no_init")
			{
				connect(currentPort()->avSource(), SIGNAL(T_findOptionsFinished()), this, SLOT(refreshSrcOptions()));
				Pkg->T_findOptions();
			} else		
				refreshSrcOptions(); /// the slot does it
				
				
			wsAdvanced->raiseWidget(1);
			}break;

		case 2:{ /** avbinary package  TODO this has to be reworked**/
			QBsdPortAvBinPkg *Pkg = currentPort()->avBinary();
			
			/// name
			eName->setText(Pkg->name()); 
			/// categories
			eCategories->setText(Pkg->categories());	
			/// maint
			eMaint->setText(Pkg->maint());
			/// url
			eWWW->setText(Pkg->www());
			eWWW->setURL(Pkg->www());
			/// comment
			eComment->setText(Pkg->comment());
			/// updating warning		
/*			if ( (UPDATINGTab==0) )
			{
				UPDATINGTab = extendedInfo->page(0);
				extendedInfo->removePage(UPDATINGTab);
			} 
*/			/// description
			if (QBsdPort::global->combinePkgInfo)
			{
				if (Pkg->descr() == "no_init") /// may not be retrieved yet -> REMEMBER: uses avsrc's data
				{
					connect(currentPort()->avSource(), SIGNAL(T_findDescrFinished()), this, SLOT(refreshSrcDescr()));
					currentPort()->avSource()->T_findDescr();
					
				} else
					refreshSrcDescr();
			} else				
				eDescr->setText(i18n("Binary Packages do not provide this field of information. "
							"Check the Source or activate \"Combine Information\" in the "
							"Options to have KPorts load missing information from other"
							"Packages of this Port automatically."));
			/// files
			if (QBsdPort::global->combinePkgInfo)
			{
				if (Pkg->files()== "no_init") /// may not be retrieved yet  -> REMEMBER: uses avsrc's data
				{
					connect(currentPort()->avSource(), SIGNAL(T_findFilesFinished()), this, SLOT(refreshSrcFiles()));
					currentPort()->avSource()->T_findFiles();
					
				} else
					refreshSrcFiles(); /// the slot does it
			} else
			{
				QListViewItem* tmpitem = new QListViewItem(lFiles);
				tmpitem->setText(0, i18n("Binary Packages do not provide this field of information."));
				tmpitem = new QListViewItem(lFiles);
				tmpitem->setText(0, i18n("Check the Source or activate \"Combine Information\" in the"));
				tmpitem = new QListViewItem(lFiles);
				tmpitem->setText(0, i18n("Options to have KPorts load missing information from other"));
				tmpitem = new QListViewItem(lFiles);
				tmpitem->setText(0, i18n("Packages of this Port automatically."));	
			}
			tFiles->setText(i18n("To-Be Installed Files:"));			
			lFiles->adjustColumn(0);
			/// size, have to make sure they're not there
			tSize->hide(); 
			eSize->hide();
			/// dependencies and requirements
			lReqs->clear();
			if (Pkg->reqs()!="")
			{
				QStringList tmp = QStringList::split(' ', Pkg->reqs());
				QString tmp2;
				QListViewItem* tmpitem;
				for ( QStringList::Iterator it = tmp.begin(); it != tmp.end(); it++ )
				{
					tmp2 = *it;
	
					tmpitem = new QListViewItem(lReqs);
					tmpitem->setText(0, tmp2);
					tmpitem->setPixmap(0,IconLoader.loadIcon((QString)"package", KIcon::Small));			
				}
			}
			tDeps->hide();/// make sure these arent there (only installed ports have deps!)
			lDeps->hide();

			/// prefix
			tPrefix->setText(i18n("Default Installation Prefix:"));
			ePrefix->setText(Pkg->prefix());

			/// security warnings
			if (QBsdPort::global->portaudit)
			{
				if (Pkg->vulna()=="no_init")
				{
					connect(currentPort()->avBinary(), SIGNAL(T_findVulnaFinished()), this, SLOT(refreshVulna()));
					currentPort()->avBinary()->T_findVulna();
				} else		
					refreshVulna(); /// the slot does it
			}
			wsAdvanced->raiseWidget(1);
			
			
			}break;
		default: break;
	}




}

void KPortsView::refreshInstSize()
{
	/// if installed version of port is displayed
	if ( (TPortInfo->isEnabled()) && (currentPkg()==0) )
	{
		uint siza = currentPort()->installed()->size() / 1024;
		eSize->setText(QString::number(siza));	
	}	

}

void KPortsView::refreshInstFalseFiles()
{
	/// if installed version of port is displayed
	if ( (TPortInfo->isEnabled()) && (currentPkg()==0) )
	{
		lFiles->addColumn(i18n("Checksum"));
		for (QListViewItem* currentItem = lFiles->firstChild(); currentItem; currentItem = currentItem->nextSibling() )
		{
			if (currentPort()->installed()->falseFiles().contains("|" + currentItem->text(0) + "!|"))
			{
				currentItem->setText(1,i18n("file missing"));
				currentItem->setPixmap(1,IconLoader.loadIcon((QString)"messagebox_warning", KIcon::Small));
			} else if (currentPort()->installed()->falseFiles().contains("|" + currentItem->text(0) + "|"))
			{
				currentItem->setText(1,i18n("mismatch"));
				currentItem->setPixmap(1,IconLoader.loadIcon((QString)"messagebox_warning", KIcon::Small));
			} else
			{
				currentItem->setText(1,i18n("match"));
				currentItem->setPixmap(1,IconLoader.loadIcon((QString)"ok", KIcon::Small));
			}
		}
		lFiles->adjustColumn(1);
	}		

}

void KPortsView::refreshSrcDescr()
{
	if ( (TPortInfo->isEnabled()) && (currentPkg()>=1) )
		if (currentPort()->avSource()->descr()!="no_init")
			eDescr->setText(currentPort()->avSource()->descr());


}

void KPortsView::refreshSrcFiles()
{
	if ( (TPortInfo->isEnabled()) && (currentPkg()>=1) )
	{
		QApplication::setOverrideCursor(KCursor::workingCursor());
		lFiles->clear();
		if ( (currentPort()->avSource()->files()!="") && (currentPort()->avSource()->files()!="no_init") )
		{
			QStringList tmp = QStringList::split('|', currentPort()->avSource()->files());
			QString tmp2;
			QListViewItem* tmpitem;
			for ( QStringList::Iterator it = tmp.begin(); it != tmp.end(); it++ )
			{
				tmp2 = *it;

				tmpitem = new QListViewItem(lFiles);
				tmpitem->setText(0, tmp2);
				tmpitem->setPixmap(0,IconLoader.loadIcon((QString)"unknown", KIcon::Small));
				
				
			}
		}
		lFiles->adjustColumn(0);
		lFiles->removeColumn(1);
				
		QApplication::restoreOverrideCursor();
	}

	
}

void KPortsView::refreshSrcOptions()
{
	tNoOptions->show();			
	if ( (currentPort()->avSource()->options()=="") || (currentPort()->avSource()->options()=="no_init") )
		return;
	
	tNoOptions->hide();
	QStringList list = QStringList::split("\n", currentPort()->avSource()->options());
	QString tmp("");
	
	for ( QStringList::Iterator it = list.begin(); it != list.end(); ++it)
	{ 
		tmp = *it;
		QCheckBox *checker = new QCheckBox(optionsGroup);
		checker->setText(tmp.section('|', 1,1));
		if (tmp.section('|', 2,2) == "on")
			checker->setChecked(true);
		else
			checker->setChecked(false);
		checker->setEnabled(false);
		checker->show();
		optionsGroup->layout()->activate();
		
//		QMessageBox::information(this, i18n("popup"), tmp, QMessageBox::Ok|QMessageBox::Default);
		
		QToolTip::add(checker, i18n("You can change these Options during Install, if installing from Source.\nBinaray Packages usually come with default Options."));
	}
			
}


void KPortsView::refreshVulna()
{

//	std::cout << "-->> vulner-inst:" << currentPort()->installed()->vulna().latin1() <<  std::endl;
//	QPixmap warning = IconLoader.loadIcon((QString)"messagebox_warning", KIcon::Small);
//	QPixmap ok	= IconLoader.loadIcon((QString)"ok", KIcon::Small);
	
	QString vulna("");
	switch(currentPkg())
	{
		case 0: /// installed
			vulna = currentPort()->installed()->vulna(); break;
		case 1: /// av source
			vulna = currentPort()->avSource()->vulna(); break;
		case 2: /// av binary
			vulna = currentPort()->avBinary()->vulna(); break;
	}
				
	if ( (vulna!="") && (vulna!="no_init") )
	{
		tNoSec->hide();
		QStringList vulnalist = QStringList::split("\n", vulna);
		QString genervt("");
		for ( QStringList::Iterator it = vulnalist.begin(); it != vulnalist.end(); ++it)
		{ 
			genervt = *it;
			KURLLabel *label = new KURLLabel(secGroup);
			label->setText(genervt.section('|',0,0).section(" -- ", 1, 1));
			label->setURL(genervt.section('|',1,1));
			label->show();
			label->setHighlightedColor(QString("red"));
			label->setSelectedColor(QString("red"));
			label->setUnderline(false);
			label->setGlow(false);
			label->setFloat(true);
			secGroup->layout()->activate();
			connect(label, SIGNAL(leftClickedURL(const QString&)), this, SLOT(URLClicked(const QString& )));
			
			QToolTip::add(label, i18n("Click for more Information"));
		}
		
	} else
	{
		tNoSec->show();
	}

}
			
void KPortsView::refreshFlags()
{
	if (!currentPort()->avSource())
		return;
	
	QString string("");
	QButton *checkbox;
	QLabel *label;
	bool	show = false;
	for (int i = 0; i< 5; i++)
	{
		checkbox = 0;
		switch(i)
		{
			case 0: string = currentPort()->avSource()->ignore(); 		checkbox = cIgnore; 	label = eIgnore; break;
			case 1: string = currentPort()->avSource()->restricted();	checkbox = cRestricted; label = eRestricted; break;
			case 2: string = currentPort()->avSource()->broken(); 		checkbox = cBroken;	label = eBroken; break;
			case 3: string = currentPort()->avSource()->forbidden();	checkbox = cForbidden;	label = eForbidden; break;
			case 4: string = currentPort()->avSource()->deprecated(); 	checkbox = cDeprecated;	label = eDeprecated; break;
		}
		
		if ( (string != "" ) && (string != "no_init" ) && (checkbox) )
		{
/*			checkbox->setText(string);
			if (string.length()>100)
			{
				string.replace(", ", ",\n");
				string.replace(". ", ".\n");
			}*/
			label->setText(string);
			label->show();
			checkbox->show();
			show = true;
		}
	}
	
	if (show)
		flagGroup->show();
}


void KPortsView::ItemExpanded(QListViewItem* cat)
{
	cat->setPixmap(0,IconLoader.loadIcon((QString)"folder_open", KIcon::Small));
}

void KPortsView::ItemCollapsed(QListViewItem* cat)
{
	cat->setPixmap(0,IconLoader.loadIcon((QString)"folder", KIcon::Small));

}


void KPortsView::InstallPressed()
{
	QBsdPort* tmpport = currentPort();

	if (g_bHideMainOnInstall)
		app->hide();

	InstallWizard wiztemp(this, 0, 1);
	wiztemp.exec();


//	clearTab();

//	isStarting = true;
//	allInstFound();
//	isStarting = false;
	QApplication::setOverrideCursor(KCursor::waitCursor());
	
	setCurrentPort(tmpport);
	updateTab();
	
	
	if (g_bHideMainOnInstall)
		app->show();
		
	QApplication::restoreOverrideCursor();

}

void KPortsView::upgradeAll()
{
	/** we will now construct a virtual port that depends on all installed
	ports. thus we will be able to use the normal installer to upgrade **/
	
	QBsdPort *allInst = new QBsdPort;
	
	allInst->setOrigin("virtual/all_installed");
	
	
	setCurrentPort(allInst);
	
	
	if (g_bHideMainOnInstall)
		app->hide();

	InstallWizard wiztemp(this, 0, 2);
	wiztemp.exec();

	if (g_bHideMainOnInstall)
		app->show();
	

}


void KPortsView::UninstallPressed()
{
	QBsdPort* tmpport = currentPort();

	if (g_bHideMainOnInstall)
		app->hide();

	InstallWizard wiztemp(this, 0, 0);
	wiztemp.exec();

	QApplication::setOverrideCursor(KCursor::waitCursor());

//	clearTab();

//	isStarting = true;
//	allInstFound();
//	isStarting = false;
	
	setCurrentPort(tmpport);
	updateTab();
	
	if (g_bHideMainOnInstall)
		app->show();
		
	QApplication::restoreOverrideCursor();
}
/*
void KPortsView::eSearchChanged()
{

}*/

void KPortsView::ExpandAll()
{
	if (currentListView()->firstChild()==0)
		return;

	QListViewItem*	current = currentListView()->firstChild();

//	while (!current->isVisible())
//		if (current->nextSibling()!=0)
//			current = current->nextSibling();

	while (current!=0)
	{
		if (current->parent()==0)
			current->setOpen(true);

		current = current->nextSibling();
	}


}

void KPortsView::CollapseAll()
{

	if (currentListView()->firstChild()==0)
		return;

	QListViewItem*	current = currentListView()->firstChild();
	
//	while (!current->isVisible())
//		if (current->nextSibling()!=0)
//			current = current->nextSibling();

	while (current!=0)
	{
//		if ( (current->parent()==0) && (current->isOpen()) )
			current->setOpen(false);
		current = current->nextSibling();
	}

}

void KPortsView::eSearchDescrPressed()
{


	QApplication::setOverrideCursor(KCursor::workingCursor());
	
	ListViewSearch->clear();



	QListViewItem *temp3 = new KListViewItem(ListViewSearch);
	temp3->setPixmap(0,IconLoader.loadIcon((QString)"info", KIcon::Small));
	temp3->setText(0,i18n("Searching..."));
	bClearSearch->setEnabled(false);

	bSearchDescr->setEnabled(false);
	eSearchDescr->setEnabled(false);
	cbSearchType->setEnabled(false);

	//clear information 
	clearTab();


	QBsdPort::global->T_search(eSearchDescr->text(), cbSearchType->currentItem(), cExact->isChecked());
	

}

KListView *KPortsView::currentListView()
{
	switch(MainTab->currentPageIndex())
	{
		case 1:
			return ListViewInst;
		case 2:
			return ListViewSearch;
		default:
			return ListView;	
	}

}


void KPortsView::vulnaDbOutdated()
{
	if (KMessageBox::questionYesNo(this, i18n("Your vulnerablility database is outdated. Do you wish to update it?"
						"\nNOTE: KPorts can only read from an up-to-date Database."),
						i18n("Vulnerability Database"),
						KStdGuiItem::yes(),
						KGuiItem(i18n("Don't use the Db"), "no", i18n("You can turn Port Auditing back on in th Options.")))
						 == KMessageBox::Yes)
		QBsdPort::global->T_updateVulnaDb();
	else
		QBsdPort::global->portaudit = false;

}
		
void KPortsView::updateVulnaDb() /// needed by the menu/toolbar action
{
	if (KMessageBox::warningContinueCancel(this, i18n("KPorts will now update your Vulnerability Database"), 
						i18n("Vulnerability Database"),
						KStdGuiItem::cont(),
						"dontAskUpdateVulnaDb") == KMessageBox::Continue)
	{
		QBsdPort::global->T_updateVulnaDb();	
		QApplication::setOverrideCursor(KCursor::workingCursor());
	}

}
void	KPortsView::vulnaDbUpdatedSuccessfully()
{
	KMessageBox::information(this, i18n("Your vulnerablility database was updated successfully."), i18n("Vulnerability Database"));
	QApplication::restoreOverrideCursor();
}
void	KPortsView::vulnaDbUpdatedUnsuccessfully(QString error)
{
	KMessageBox::detailedError(this, i18n("Your vulnerablility database could not be updated. "), i18n("This is the log:\n")+error, i18n("Vulnerability Database"));
	QApplication::restoreOverrideCursor();

}

void	KPortsView::updatePorts()
{

	if (g_bHideMainOnInstall)
		app->hide();
		
	UpdateAvSrc dlg;
				
	dlg.exec();
		
	KMessageBox::information(this, i18n("KPorts needs to restart for the changes to take affect."
					"\nIt will do so now."),
					QString(), "dontWarnReloadIndex");
	this->hide();
	
	KRun::runCommand("kports");
	
	kapp->exit();
	
		
		
}
		
		
void KPortsView::indexFileNotFound()
{

	KMessageBox::information(this, i18n("The INDEX file cannot be found in your ports directory.\nCheck if the Paths are set right in the Configuration."));

}

void KPortsView::URLClicked(const QString& url)
{
/*	if (geteuid() == 0)
	{
		QString username = getlogin();//(std::getenv("LOGNAME"));
		uint user_id  = getpwnam(username.latin1())->pw_uid;
		
		std::cout << "LOGIN USER'S ID: "<< user_id<< std::endl;
			
		setuid(user_id);
		seteuid(user_id);
	}*/
	
	if (url != "")
		KRun::runURL(url, "text/html");
		
/*	if (getuid==0)
		seteuid(0);*/
		
	
}

void KPortsView::MaintClicked()
{
//	KRun::runURL((QString)"mailto:"+(QString)eMaint->text(), "text/html");

/*	if (geteuid() == 0)
	{
		QString username = getlogin();//(std::getenv("LOGNAME"));
		uint user_id  = getpwnam(username.latin1())->pw_uid;
		
		std::cout << "LOGIN USER'S ID: "<< user_id<< std::endl;
			
		setuid(user_id);
	}*/
		
	if ( (eMaint->isEnabled()) && (eMaint->text()!="") && (eMaint->text()!="Loading...") )
		new KRun((QString)"mailto:"+(QString)eMaint->text());

/*	if (getuid==0)
		seteuid(0);*/
}


void KPortsView::installViewFilterChanged(int filter)
{
	eSearchInst->updateSearch("");
	ListViewInst->clear();
	switch (filter)
	{

		case 0: /// show all installed 
			for (QBsdPort *port = QBsdPort::global->array.first(); port; port = QBsdPort::global->array.next())
			{
				if (port->installed())
					insertPortInView(ListViewInst, port);
			} break;
		case 1: /// show all installed and upgradable
			bool doit;
			for (QBsdPort *port = QBsdPort::global->array.first(); port; port = QBsdPort::global->array.next())
			{
				doit = false;
				if ( (port->installed()) && (port->avSource()) )
					if (port->installed()->version() < port->avSource()->version() ) 
						doit = true;
				if ( (port->installed()) && (port->avBinary()) && !doit)
					if (port->installed()->version() < port->avBinary()->version() ) 
						doit = true;
				if (doit)
					insertPortInView(ListViewInst, port);
			} break;
		case 2: /// show all installed and vulnarable
			if (!QBsdPort::global->portaudit)
				return;
			for (QBsdPort *port = QBsdPort::global->array.first(); port; port = QBsdPort::global->array.next())
			{
				if (port->installed())
					if ( (port->installed()->vulna() != "") && (port->installed()->vulna() != "no_init") ) 
						insertPortInView(ListViewInst, port);
					
			} break;
	}

	eSearchInst->updateSearch();

/*	if (ListViewInst->firstChild() == 0)
	{
		QListViewItem *tmpitem = new QListViewItem(ListViewInst);
		tmpitem->setText(0,i18n("No matching installed Packages"));
		tmpitem->setPixmap(0,IconLoader.loadIcon((QString)"info", KIcon::Small));
	}	*/


}
void KPortsView::instVersionSelected()
{
	QApplication::setOverrideCursor(KCursor::waitCursor());
	bInst->setOn(true);
	setCurrentPkg(0);
	showInfo();
	QApplication::restoreOverrideCursor();
}


void KPortsView::avSrcVersionSelected()
{
	QApplication::setOverrideCursor(KCursor::waitCursor());
	bAvSrc->setOn(true);
	setCurrentPkg(1);
	showInfo();
	QApplication::restoreOverrideCursor();
}
							
void KPortsView::avBinVersionSelected()
{
	QApplication::setOverrideCursor(KCursor::waitCursor());
	bAvBin->setOn(true);
	setCurrentPkg(2);
	showInfo();
	QApplication::restoreOverrideCursor();
}
						

void KPortsView::pkgExportedSuccessfully()
{
	QApplication::restoreOverrideCursor();
	bExportPkg->setEnabled(true);
	KMessageBox::information(this, i18n("The package file was created successfully."), i18n("Package export"));
}
							
void KPortsView::pkgExportedUnsuccessfully(QString error)
{
	QApplication::restoreOverrideCursor();
	bExportPkg->setEnabled(true);
	KMessageBox::detailedError(this, i18n("The package file could not be created. "), i18n("This is the log:\n")+error, i18n("KPorts - Package export"));

}
void KPortsView::exportPkgClicked()
{
	QApplication::setOverrideCursor(KCursor::workingCursor());
	bExportPkg->setEnabled(false);
	currentPort()->installed()->T_exportPkg(ePkgURL->url());

}

void KPortsView::showUpdRest()
{
	KMessageBox::information(this, i18n("KPorts reads the UPDATING file while starting, filters out warnings that are too old and"
					" - if possible - attaches each warning to the port(s) it belongs to."
					"\nYou will be shown those warnings that could not be matched, now."), QString(), "dontWarnUpdRest");
							
	KRun::runCommand("kwrite " + QDir::homeDirPath() + "/.kports/rest_of_updating");
							
}

void KPortsView::showMoved()
{
	KRun::runCommand("kwrite " + QBsdPort::global->portsDir + "/MOVED");
							
}
#include "kportsview.moc"
