/***************************************************************************
 *   Copyright (C) 2005, 2006 by Hannes Hauswedell                         *
 *   hannes.hauswedell@gmail.com                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "pref.h"


KPortsPreferences::KPortsPreferences()
    : KPortsPrefBase()
{
	///ftp mirrors for freebsd
/*	mirrors_fbsd_ports = ""; mirrors_fbsd_ports << "ftp" << "ftp2"<< "ftp3" << "ftp3" << "ftp3" << "ftp3" << "ftp4" << "ftp5" << "ftp6"
	<< "ftp7" << "ftp8" << "ftp9" << "ftp10" << "ftp11" << "ftp12" << "ftp13" << "ftp14" << "ftp.ar" << "ftp.au" << "ftp2.au" << "ftp3.au" 
	<< "ftp.at" << "ftp2.at" << "ftp.br" << "ftp2.br" << "ftp3.br" << "ftp4.br" << "ftp5.br" << "ftp6.br" << "ftp7.br" << "ftp.bg" << "ftp.ca"
	<< "ftp2.ca" << "ftp3.ca" << "ftp.cn" << "ftp2.cn" << "ftp.hr" << "ftp.cz" << "ftp.dk" << "ftp2.dk" << "ftp3.dk" << "ftp.ee" << "ftp.fi" 
	<< "ftp3.fi" << "ftp.fr" << "ftp2.fr" << "ftp3.fr" << "ftp5.fr" << "ftp6.fr" << "ftp7.fr" << "ftp8.fr" << "ftp.de" << "ftp2.de" << "ftp3.de"
	<< "ftp4.de" << "ftp5.de" << "ftp6.de" << "ftp7.de" << "ftp8.de" << "ftp.gr" << "ftp2.gr" << "ftp.hk" << "ftp.hu" << "ftp2.hu" << "ftp.is"
	<< "ftp.id" << "ftp.ie" << "ftp2.ie" << "ftp3.ie" << "ftp.il" << "ftp.it" << "ftp.jp" << "ftp2.jp" << "ftp3.jp" << "ftp4.jp" << "ftp5.jp"
	<< "ftp6.jp" << "ftp7.jp" << "ftp8.jp" << "ftp9.jp" << "ftp.kr" << "ftp2.kr" << "ftp.lv" << "ftp2.lv" << "ftp.lt" << "ftp.nl" << "ftp2.nl"
	<< "ftp.nz" << "ftp.no" << "ftp3.no" << "ftp.pl" << "ftp2.pl" << "ftp3.pl" << "ftp5.pl" << "ftp.pt" << "ftp2.pt" << "ftp4.pt" << "ftp.ro"
	<< "ftp1.ro" << "ftp.ru" << "ftp2.ru" << "ftp3.ru" << "ftp4.ru" << "ftp5.ru" << "ftp.sg" << "ftp.sk" << "ftp.si" << "ftp2.si" << "ftp.za"
	<< "ftp2.za" << "ftp3.za" << "ftp4.za" << "ftp.es" << "ftp2.es" << "ftp3.es" << "ftp.se" << "ftp2.se" << "ftp3.se" << "ftp5.se" << "ftp.ch"
	<< "ftp2.ch" << "ftp.tw" << "ftp2.tw" << "ftp3.tw" << "ftp4.tw" << "ftp5.tw" << "ftp6.tw" << "ftp7.tw"  << "ftp.tr" << "ftp.ua" << "ftp2.ua"
	<< "ftp3.ua" << "ftp4.ua" << "ftp5.ua" << "ftp6.ua" << "ftp7.ua" << "ftp.uk" << "ftp2.uk" << "ftp3.uk" << "ftp4.uk" << "ftp5.uk" << "ftp6.uk"
	<< "ftp.us" << "ftp2.us" << "ftp3.us" << "ftp4.us" << "ftp5.us" << "ftp6.us" << "ftp7.us" << "ftp8.us" << "ftp9.us" << "ftp10.us";*/
	
	mirrors_fbsd_ports = ""; mirrors_fbsd_ports << "ar" << "au" << "at" << "br" << "bg" << "ca" << "cn" << "hr" << "cz" << "dk" 
	<< "ee" << "fi" << "fr" << "de" << "gr" << "hk" << "hu" << "is"<< "id" << "ie"  << "il" << "it" << "jp" << "kr" <<  "lv" 
	<< "lt" << "nl" << "nz" << "no" << "pl" << "pt" << "ro" << "ru" << "sg" << "sk" << "si" << "za" << "es" << "se" << "ch" 
	<< "tw" << "tr" << "ua" << "uk" << "us";
	 
	mirrors_fbsd_ports.sort();
/*	cvsup_mirrors_fbsd_ports = ""; cvsup_mirrors_fbsd_ports << "cvsup" << "cvsup1" << "cvsup2" << "cvsup3" << "cvsup4" << "cvsup5" << "cvsup.br"
	 << "cvsup.cn" << "cvsup.dk" << "cvsup.es" << "cvsup.hk" << "cvsup.hu" << "cvsup.id" << "cvsup.it" << "cvsup.nl" << "cvsup.pt" << "cvsup.se"
	 << "cvsup.sk" << "cvsup.tr" << "cvsup.tw" << "cvsup.uk" << "cvsup.au" << "cvsup.de" << "cvsup.jp";
	  
	cvsup_mirrors_fbsd_ports.sort();*/



	lPortsPath->setMode(26);  //allow only existing directories to be selected	

	KIconLoader IconLoader;

	first = iconView->firstItem();
	second = first->nextItem();
	third = second->nextItem();
//	fourth = third->nextItem(); /// unused right now
	
	first->setPixmap(IconLoader.loadIcon((QString)"system", KIcon::NoGroup));
	second->setPixmap(IconLoader.loadIcon((QString)"looknfeel", KIcon::NoGroup));
//	third->setPixmap(IconLoader.loadIcon((QString)"kwrite", KIcon::NoGroup));
	
	/** READ ALL OPTIONS and set the widgets to corresponding states **/
	
	if (QBsdPort::global->platform.pkgsystem==-1)		/// freebsd ports without portupgrade is internally a different platform.pkgsystem: -1
	{
		cbPlatform->setCurrentItem(0);
		cNoPortupgrade->setChecked(true);
	} else
		cbPlatform->setCurrentItem(QBsdPort::global->platform.pkgsystem);
		
	platformChanged();

	cUsePortaudit->setChecked(QBsdPort::global->portaudit);
		
	cbOS->setCurrentItem(QBsdPort::global->platform.os);	
	cbRelease->setCurrentText(QBsdPort::global->platform.release);
	cbMirror->setCurrentText(QBsdPort::global->platform.mirror);
		
	
	lPortsPath->setURL(QBsdPort::global->portsDir);
	lPkgPath->setCurrentText(QBsdPort::global->pkgSite);
	lPortsDb->setURL(QBsdPort::global->portsDbDir);
	lPkgDb->setURL(QBsdPort::global->pkgDbDir);
	lIndex->setURL(QBsdPort::global->indexPath);
	
	cKeepLogSuccess->setChecked(QBsdPort::global->keepLogsForSuccessfulProcs);
	cCombineInfo->setChecked(QBsdPort::global->combinePkgInfo);
				
	
	if (cbPlatform->currentItem()==0) /// freebsd ports
	{
		QBsdPort *tmpport = QBsdPort::global->portWithOrigin("security/portaudit");
		if (tmpport)
			if (!tmpport->installed())
			{
				cUsePortaudit->setChecked(false);
				cUsePortaudit->setEnabled(false);
				QToolTip::add(cUsePortaudit, i18n("You need to install \"security/portaudit\" to activate Security Auditing."));
			}
			
/*		tmpport = QBsdPort::global->portWithOrigin("sysutils/portupgrade");
		if (tmpport)
			if (!tmpport->installed())
			{
				cNoPortupgrade->setChecked(false);
				cNoPortupgrade->setEnabled(false);
				QToolTip::add(cUsePortupgrade, i18n("You need to install \"sysutils/portupgrade\". This is highly recommended!"));
			}*/
			
	}
	
		
				
				

	cHideMain->setChecked(KPortsView::g_bHideMainOnInstall);
//	cAutoLoad->setChecked(KPortsView::g_bListLoad);
//	cFilesTree->setChecked(KPortsView::g_bFilesTree);
	//slPreload->setValue(QBsdPort::global->m_preload);

	int year, month, day;

	year = QBsdPort::global->updDate / 10000;
	month =  (QBsdPort::global->updDate - year * 10000) / 100;
	day = (QBsdPort::global->updDate - year * 10000 - month * 100);

	QDate date(year, month, day);
	dUpdDate->setDate(date);
//	std::cout << " | DATUM:: " << year << "-"<<month<<"-"<<day;

	if (KPortsView::g_sPrefix=="")
	{
		cPrefix->setChecked(false);
		ePrefix->setEnabled(false);
		ePrefix->setURL("/usr/local/");
	}
	else
	{
		cPrefix->setChecked(true);
		ePrefix->setEnabled(true);
		ePrefix->setURL(KPortsView::g_sPrefix);
	}



//	setSizePolicy(size);	//preferres siz policy (automatic resze)

//	layout.addWidget(frame);
//	frame->layout()->add(this);
	adjustSize();

}


void KPortsPreferences::UpdateSettings()
{
		
		
	/**platform**/
		
	QBsdPort::global->platform.pkgsystem = cbPlatform->currentItem();
	QBsdPort::global->platform.os	= cbOS->currentItem();
	QBsdPort::global->platform.mirror = cbMirror->currentText();
	QBsdPort::global->platform.release = cbRelease->currentText();
		
	if ( (QBsdPort::global->platform.pkgsystem == 0) && (cNoPortupgrade->isChecked()) )
		QBsdPort::global->platform.pkgsystem = -1;
			
	/**paths**/

	QString tmp1,tmp2,tmp3,tmp4,tmp5;
	
	tmp1 = lPortsPath->url();
	tmp2 = lPkgPath->currentText();
	tmp3 = lPortsDb->url();
	tmp4 = lPkgDb->url();
	tmp5 = lIndex->url();
	

	if (tmp1!="")
	{
		QBsdPort::global->portsDir = tmp1;
		if (!QBsdPort::global->portsDir.endsWith("/"))//check if last char is / and if not add it
			QBsdPort::global->portsDir.append("/");
	}
	if (tmp2!="")
	{
		QBsdPort::global->pkgSite = tmp2;
		if (!QBsdPort::global->pkgSite.endsWith("/"))//check if last char is / and if not add it
			QBsdPort::global->pkgSite.append("/");
	}
	if (tmp3!="")
	{
		QBsdPort::global->portsDbDir = tmp3;
		if (!QBsdPort::global->portsDbDir.endsWith("/"))//check if last char is / and if not add it
			QBsdPort::global->portsDbDir.append("/");
	}
	if (tmp4!="")
	{
		QBsdPort::global->pkgDbDir = tmp4;
		if (!QBsdPort::global->pkgDbDir.endsWith("/"))//check if last char is / and if not add it
			QBsdPort::global->pkgDbDir.append("/");
	}
	if (tmp5!="")
		QBsdPort::global->indexPath = tmp5;	

	/*Options*/
	
	if (cPrefix->isChecked())
		KPortsView::g_sPrefix = ePrefix->url();
	else
		KPortsView::g_sPrefix = "";

	if ( (KPortsView::g_sPrefix!="") && (!KPortsView::g_sPrefix.endsWith("/")) )//check if last char is / and if not add it
				KPortsView::g_sPrefix.append("/");


	
	
	QBsdPort::global->portaudit	= cUsePortaudit->isChecked();

			
	KPortsView::g_bHideMainOnInstall = cHideMain->isChecked();
	//	QBsdPort::global->m_preload	= slPreload->value();

	QBsdPort::global->keepLogsForSuccessfulProcs = cKeepLogSuccess->isChecked();
	QBsdPort::global->combinePkgInfo	= cCombineInfo->isChecked();

	//date
	QDate date 			= dUpdDate->date();
	QBsdPort::global->updDate	= date.year() * 10000 + date.month() * 100 + date.day();


	//last step!!!
	KPortsView::Settings->writeConfig();
}

void KPortsPreferences::platformChanged()
{
	cbOS->clear();
	QToolTip::remove(cbOS);
	cNoPortupgrade->hide();

	switch (cbPlatform->currentItem())
	{
		case 0: cbOS->insertItem("FreeBSD");
//			cbOS->insertItem("PcBSD");
			QToolTip::add(cbOS, i18n("If you are using an unlisted Distro of FreeBSD, just pick FreeBSD."));
			cNoPortupgrade->show();			
			osChanged();
			break;
//		case 1: KMessageBox::warning(this, i18n("Error"), i18n("<font color=\"#ff0000\">PkgSrc will hopefully be supported in the next major release.</font>")); break;
		default:QMessageBox::warning(this, i18n("Error"), i18n("<font color=\"#ff0000\">This Platform is not (yet) supported, sorry.</font>")); break;
	}

}

void KPortsPreferences::osChanged()
{
	cbRelease->clear();
	switch (cbPlatform->currentItem())
	{
		case 0:{ /// freebsd-ports
			switch (cbOS->currentItem())
			{	
//				case 1: /// pcBSD
//					KMessageBox::information(this, i18n("Additional support for managing \".pbi\"-files is planned."));
				case 0:///  freebsd (original)
					cbRelease->insertItem("4-stable");
					cbRelease->insertItem("5.5-release");
					cbRelease->insertItem("5-stable");
					cbRelease->insertItem("6.1-release");
					cbRelease->insertItem("6-stable");
					cbRelease->insertItem("7-current");
					cbRelease->setCurrentItem(3);
					
					cbMirror->clear();
					cbMirror->insertStringList(mirrors_fbsd_ports);
					
					break;
			}
			}break;
		default: break;
	}
			
}
			
			
void KPortsPreferences::newIconSelected()
{
			
	if (iconView->currentItem()==first)
		wsPages->raiseWidget(0);
	else if (iconView->currentItem()==second)
		wsPages->raiseWidget(1);
	else if (iconView->currentItem()==third)
		wsPages->raiseWidget(2);
	
}

void KPortsPreferences::generatePaths()
{
	QBsdPortGlobal temp;
	temp.platform.pkgsystem = cbPlatform->currentItem();
	temp.platform.os	= cbOS->currentItem();
	temp.platform.mirror = cbMirror->currentText();
	temp.platform.release = cbRelease->currentText();
	
	temp.guessOtherEnv();
	
	lPortsPath->setURL(temp.portsDir);
	lPkgPath->setCurrentText(temp.pkgSite);
	lPortsDb->setURL(temp.portsDbDir);
	lPkgDb->setURL(temp.pkgDbDir);
	lIndex->setURL(temp.indexPath);
}

  

KPortsPrefConfig::KPortsPrefConfig(KSharedConfig::Ptr config)
		:KConfigSkeleton(config)
{

	/// create a QBsdPortGlobal object to save global data
	if (QBsdPort::global != 0)
		delete QBsdPort::global;
	QBsdPort::global = new QBsdPortGlobal();

	/// we will try to detect default values and create const objects to hold these
	QBsdPort::global->guessPlatform();
	const int	tmppkgsystem 	= QBsdPort::global->platform.pkgsystem;
	const int	tmpos 		= QBsdPort::global->platform.os;
	const QString	tmprelease	= QBsdPort::global->platform.release;
	const QString	tmpmirror	= QBsdPort::global->platform.mirror;
	QBsdPort::global->guessOtherEnv();
	const QString 	tmp1 = QBsdPort::global->portsDir;
	const QString 	tmp2 = QBsdPort::global->pkgSite;
	const QString	tmp3 = QBsdPort::global->portsDbDir;
	const QString	tmp4 = QBsdPort::global->pkgDbDir;
	const QString	tmp5 = QBsdPort::global->indexPath;

	const bool 	tmp6 = QBsdPort::global->portaudit;
	const bool 	tmp7 = QBsdPort::global->portsnatch;	
	const bool	tmp8 = QBsdPort::global->keepLogsForSuccessfulProcs;
	const bool	tmp9 = QBsdPort::global->combinePkgInfo;

	setCurrentGroup("Platform");		
        addItemInt("PackagingSystem",	QBsdPort::global->platform.pkgsystem,	tmppkgsystem);
	addItemInt("OperatingSystem",	QBsdPort::global->platform.os,	 	tmpos);
	addItemString("Release",	QBsdPort::global->platform.release,	tmprelease);
	addItemString("Mirror",		QBsdPort::global->platform.mirror,	tmpmirror);			
	setCurrentGroup("Ports Config");
	addItemString("Ports Path", 	QBsdPort::global->portsDir,	tmp1);
	addItemString("Package Site", 	QBsdPort::global->pkgSite, 	tmp2);
	addItemString("PortsDB Dir",	QBsdPort::global->portsDbDir,	tmp3);
	addItemString("PkgDB Dir",	QBsdPort::global->pkgDbDir,	tmp4);
	addItemString("Path to IndexFile",	QBsdPort::global->indexPath,	tmp5);
	addItemBool("Use Portaudit", 	QBsdPort::global->portaudit,	tmp6);
	addItemString("Custom Global Prefix",	KPortsView::g_sPrefix, "");

	addItemULong("Updating File Warnings Date", QBsdPort::global->updDate, 20040101);


	setCurrentGroup("KPorts User Interface Settings");
        addItemBool("HideMain", 		KPortsView::g_bHideMainOnInstall,	true);
	addItemBool("Keep Logs for Suc.Procs",	QBsdPort::global->keepLogsForSuccessfulProcs, tmp8);
	addItemBool("combine Pkg Info",		QBsdPort::global->combinePkgInfo, 	tmp9);
	addItemBool("combine Pkg Info",		QBsdPort::global->firstRun, 	true);


}




#include "pref.moc"
