/***************************************************************************
 *   Copyright (C) 2005, 2006 by Hannes Hauswedell                         *
 *   hannes.hauswedell@gmail.com                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "updateavsrc.h"

UpdateAvSrc::UpdateAvSrc(QWidget *parent, const char *name)
    :UpdateAvSrcBase(parent, name)
{

	if (QBsdPort::global->platform.pkgsystem != 0 )
		groupPortsDb->hide();

	connect(QBsdPort::global, SIGNAL(percentChanged(int)), this, SLOT(percentageChanged(int)));
	connect(QBsdPort::global, SIGNAL(error(QString)), this, SLOT(errorLogReceived(QString)));
		
	pbar1->hide();
	bLog1->hide();
	text1->hide();
	bLog2->hide();
	text2->hide();
	bLog3->hide();
	text3->setText("");
		
	bFinish->setEnabled(true);
	bCancel->setEnabled(false);
	
}


void UpdateAvSrc::bStart3Clicked()
{
	if (what != 1) /// not doing anything right now
	{	
		
		QBsdPort::global->T_updatePortsDb();
	
		setCurrentGroup(3);
		
		groupPorts->setEnabled(false);
		
		groupIndex->setEnabled(false);
			
		bFinish->setEnabled(false);
		

		
		what = 1;
		
		text->setText(i18n("Updating..."));
			
		bLog3->hide();
		
		bStart3->setText(i18n("abort"));
		if (getuid()!=0)	
			bStart3->setEnabled(false);

	} else
		QBsdPort::global->stopProc("updatePortsDbProc");
		
		
}


void UpdateAvSrc::bStart2Clicked()
{

	if (what != 1) /// not doing anything right now
	{	
		if (rFetch->isChecked())
			QBsdPort::global->T_updateIndex(false);
		else
		{
			if (KMessageBox::warningContinueCancel(this, i18n("Building the Index file takes really long and no information on progress is given.\n"
									"Fetching the Index is highly recommended. Continue anyway?"), QString(), KStdGuiItem::cont(),
									"genIndexSure") == KMessageBox::Continue)
				QBsdPort::global->T_updateIndex(true);
			else
				return;
		}
		
		setCurrentGroup(2);
		
		groupPorts->setEnabled(false);
		
		groupPortsDb->setEnabled(false);
			
		bFinish->setEnabled(false);
		
		ws->raiseWidget(1);
		text->show();
		
		what = 1;
		
		if (rFetch->isChecked())
			text->setText(i18n("Fetching..."));
		else
			text->setText(i18n("Generating..."));
			
		bLog2->hide();
		
		bStart2->setText(i18n("abort"));
		if (getuid()!=0)	
			bStart2->setEnabled(false);
		bFinish->setEnabled(false);
	} else
		QBsdPort::global->stopProc("updateIndexProc");
	
		
}


void UpdateAvSrc::bStart1Clicked()
{
	if (what != 1) /// not doing anything right now
	{
//		KMessageBox::information(this, "uid: " + QString::number(getuid)
		bStart1->setText(i18n("abort"));
		if (getuid()!=0)	
			bStart1->setEnabled(false);
		else
			bStart1->setEnabled(true);
		bFinish->setEnabled(false);
		
		what = 1;
		
		setCurrentGroup(1);
	
		groupIndex->setEnabled(false);
	
		groupPortsDb->setEnabled(false);
		
		bFinish->setEnabled(false);
		
		bLog1->hide();
		text1->hide();
		
		ws->raiseWidget(0); /// bring up progress bar
			
		QBsdPort::global->T_updatePortsDir();

		bar->show();
	} else
		QBsdPort::global->stopProc("updatePortsDirProc");
	
	
}

void UpdateAvSrc::percentageChanged(int Value)
{
	if (currentGroup == 1)
		bar->setProgress(Value);

	if (Value==100)
	{
		text->show();
		text->setText("<font color=\"#00BB00\">Update Successfull</font>");
		

		bFinish->setEnabled(false);
		
		groupPorts->setEnabled(true);
		
		groupIndex->setEnabled(true);
		
		groupPortsDb->setEnabled(true);
		
		bFinish->setEnabled(true);
		
		what = 2;
		
		switch(currentGroup)
		{
			case 1: ws->raiseWidget(1);
				bStart1->setText(i18n("start"));
				bStart1->setEnabled(true);
				break;
			case 2: ws->raiseWidget(1);
				bStart2->setText(i18n("start"));
				bStart2->setEnabled(true);
				break;
			case 3: bStart3->setText(i18n("start"));
				bStart3->setEnabled(true);
				break;
		}
	
	}


	
}

void UpdateAvSrc::bLog3Clicked()
{

	KMessageBox::detailedError(this, i18n("A Log was saved at ") + errorLog3 +i18n(" .\nPress \"Details\" to preview it."), getLastLinesFromFile(errorLog3, 5), i18n("Error"));
}


void UpdateAvSrc::bLog2Clicked()
{

	KMessageBox::detailedError(this, i18n("A Log was saved at ") + errorLog2 +i18n(" .\nPress \"Details\" to preview it."), getLastLinesFromFile(errorLog2, 5), i18n("Error"));
}


void UpdateAvSrc::bLog1Clicked()
{

	KMessageBox::detailedError(this, i18n("A Log was saved at ") + errorLog1 + i18n(" .\nPress \"Details\" to preview it."), getLastLinesFromFile(errorLog1, 5), i18n("Error"));
}

void UpdateAvSrc::errorLogReceived(QString Error)
{


	*errorLog = Error;
	
	groupPorts->setEnabled(true);
	
	groupIndex->setEnabled(true);
	
	groupPortsDb->setEnabled(true);

	text->show();
	text->setText("<font color=\"#BB0000\">Update cancelled or Error.</font>");
			
	bFinish->setEnabled(true);
			
	what = 3;
			
	if (currentGroup == 1)
	{
		ws->raiseWidget(1);
		bLog1->show();
		bStart1->setText(i18n("retry"));
		bStart1->setEnabled(true);
	} else if (currentGroup == 2)
	{
		ws->raiseWidget(2);
		bLog2->show();
		bStart2->setText(i18n("retry"));
		bStart2->setEnabled(true);
	} else
	{
		bLog3->show();
		bStart3->setText(i18n("retry"));
		bStart3->setEnabled(true);
	}
		
}


QString UpdateAvSrc::getLastLinesFromFile(QString pathToFile, int lines)
{
	QFile file(pathToFile);
	
	if (!file.exists())
		return "file doesn't exist...";

	file.open(IO_ReadOnly);
	
	file.at(file.size());
	
	int count = 0;
	
	while ( (count <= lines) && (file.at() > 0) )
	{
		file.at(file.at()-1);
		QChar ch = file.getch();
		file.at(file.at()-1); /// two times because getch moves one forward
		
		if (ch == '\n')
			count++;
		
	}

	QString r = file.readAll();
	
	file.close();
	
	return r;
}



#include "updateavsrc.moc"
