/***************************************************************************
 *   Copyright (C) 2005, 2006 by Hannes Hauswedell                         *
 *   hannes.hauswedell@gmail.com                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef UPDATEAVSRC_H
#define UPDATEAVSRC_H

#include "kportsview.h"
#include "updateavsrcbase.h"
#include "bsdport.h"

class UpdateAvSrc: public UpdateAvSrcBase 
{
Q_OBJECT
private:
	int currentGroup;	/// which group is current
	int what;		/** what is being done
				0 = nothing
				1 = updating
				2 = finished successfully
				3 = finished with error
				**/
	/// these always point to the current groups widgets
	KProgress *bar;
	QWidgetStack *ws;
	QPushButton *log;
	QLabel *text;

	QString	*errorLog;
	
	QString errorLog1, errorLog2,errorLog3; /// this is the path to the logfile
	
	
	/// gets us the end of a log file
	QString	getLastLinesFromFile(QString pathToFile, int lines);
	
	
public slots:
    virtual void bStart3Clicked();
    virtual void bStart2Clicked();
    virtual void bStart1Clicked();
    virtual void bLog3Clicked();
    virtual void bLog2Clicked();
    virtual void bLog1Clicked();
    
    virtual void percentageChanged(int);
    virtual void errorLogReceived(QString log);
    
public:
	UpdateAvSrc(QWidget *parent = 0, const char *name = 0);
	
	void setCurrentGroup(int value)
	{
		currentGroup = value;
		switch(currentGroup)
		{
			case 1 : bar = pbar1;
				ws = ws1;
				log = bLog1;
				errorLog = &errorLog1;
				text = text1;
				break;
			case 2 : bar = NULL;
				ws = ws2;
				log = bLog2;
				text = text2;
				errorLog = &errorLog2;
				break;
			case 3 : bar = NULL;
				ws = NULL;
				log = bLog3;
				text = text3;
				errorLog = &errorLog3;
				break;
			default: break;
		}
	}

	~UpdateAvSrc()
	{
//		QBsdPort::global->disconnect(this);
	}
};

#endif
